#include "DEStackWindow.H"

DStackWindow::DStackWindow(QPopupMenu* view = 0, int index = 0, QWidget * parent = 0, const char * name = 0, MyMainWindow* mw=0):QMultiLineEdit(parent,name)
{
  mwWid=mw;
  currLine = 0;
  _view = view;
  _index = index;
}

void DStackWindow::mousePressEvent(QMouseEvent * e)
{
  if ( e->button() == RightButton ) {
    int x;
    int y;
    QMouseEvent e_new(QEvent::MouseButtonPress, e->pos(),LeftButton,LeftButton);
    QMultiLineEdit::mousePressEvent(&e_new);
    getCursorPosition(&x, &y);
    if (lineLength(x)) {
      currLine = x;
      setSelection(x, 0, x, lineLength(x));
      QPopupMenu *popup = new QPopupMenu( this );
      int id[1];
      id[0] = popup->insertItem("OPEN",mwWid,SLOT(doExpandTrans()));
      popup->setItemEnabled(id[0],true);
      int r = popup->exec( e->globalPos());
    }
  }
  else
    QMultiLineEdit::mousePressEvent(e);
}


void DStackWindow::mouseReleaseEvent(QMouseEvent * e)
{
  QMultiLineEdit::mouseReleaseEvent(e);
  int x = 0;
  int y = 0;
  getCursorPosition(&x, &y);
}

int DStackWindow::getCurrLine()
{
  return currLine;
}

bool DStackWindow::close( bool alsoDelete ) {
  if (_view->isItemChecked(_index)) 
    _view->setItemChecked(_index, false);
  return QWidget::close(alsoDelete);
}
