//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Daniel Abadi
//  FILE: DETransformation.H
//  PROJ: COKO DEBBUGGER
//  DATE: WINTER 2002                                                    
//
// SYNOPSIS
//  Classes for Transformation Display List.
//  
//////////////////////////////////////////////////////////////////////////////


#ifndef _DTRANSFORMATIONLIST_H_
#define _DTRANSFORMATIONLIST_H_

#include <stdlib.h>
#include <string.h>
#include <iostream.h>
#include "RuleBlockList.H"
#include "MyMultiLineEdit.H"

class MyMultiLineEdit;

class DTransformationNode
{
public:
  
  RuleBlockNode * _value;
  MyMultiLineEdit *_widget;
  char * _contents;
  int _viewIndex;
  DTransformationNode * _next;

  DTransformationNode(RuleBlockNode* rbn, MyMultiLineEdit *widget, char* contents, int viewIndex);
  // Constructor

  ~DTransformationNode();
  // Destructor

  void display();
  //for debugging purposes only

};

class DTransformationList
{
private:
  DTransformationNode * _iterator;
  DTransformationNode * _head;
  DTransformationNode * _tail;

public:

  DTransformationList();
  // Constructor
  
  ~DTransformationList();
  // Destructor

  void insert(RuleBlockNode* rbn, MyMultiLineEdit *widget, char* contents, int viewIndex);
  // Insert a new node with _value = rbn and _contents = contents
  // and _viewIndex = viewIndex and _widget = widget to the list

  int pop();
  // Pop off a front node from the list
  // Return success value of the pop.

  RuleBlockNode* top();
  // Returns _value of the top node.

  int empty();
  // Is the list empty?

  void initIterator();
  // Initialize _iterator
  // This method is used with getValue method

  RuleBlockNode* iteratorValue();
  // Returns _value of the node that _iterator is pointing to.

  RuleBlockNode* iteratorNextValue();
  // Returns _value of the next node that _iterator is pointing to.

  MyMultiLineEdit* iteratorWindow();
  // Returns the _widget of the node that _iterator is pointing to.

  MyMultiLineEdit* iteratorNextWindow();
  // Returns the _widget of the next node that _iterator is pointing to.

  int iteratorViewIndex();
  // Returns _viewIndex of the node that _iterator is pointing to.

  int iteratorNextViewIndex();
  // Returns _viewIndex of the next node that _iterator is pointing to.

  void moveIterator();
  // make _iterator point to the next value

  int deleteNext();
  // Deletes the next node that the _iterator is pointing to.

  RuleBlockNode* getNextValue();
  // Point _iterator to the next node and returns the _value of the next node
  // after that.
  // One can call this methods repeatly to get the _value of all the nodes.
  // However, initIterator has to be called before the initial call to this 
  // method.  

  void display();
  //for debugging purposes only

  int find(const char* name);
  // Points _iterator to the previous node from the node that has the given
  // value, and returns 1 if that value was found.
  // If the node that has the given value is the _head of the list, the it
  // points _iterator to the head and returns 2.
  // If the given value is not in the list, _iterator points to NULL and
  // 0 is returned.


};

#endif

