//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Daniel Abadi
//  FILE: DEWhichList.H
//  PROJ: COKO DEBBUGGER
//  DATE: WINTER 2002                                                    
//
// SYNOPSIS
//  Classes for Which List.
//  
//////////////////////////////////////////////////////////////////////////////


#ifndef _DEWHICHLIST_H_
#define _DEWHICHLIST_H_

#include <stdlib.h>
#include <string.h>
#include <iostream.h>

class DWhichNode
{
public:
  int _which;
  DWhichNode * _next;

  DWhichNode(int which);
  // Constructor

  ~DWhichNode();
  // Destructor

  void display();
  //for debugging purposes only

};

class DWhichList
{
private:
  DWhichNode * _iterator;
  DWhichNode * _head;
  DWhichNode * _tail;

public:

  DWhichList();
  // Constructor
  
  ~DWhichList();
  // Destructor

  void insert(int which);
  //  Insert a new node with _which = which to the list

  void push(int which);
  // Push a new node with _which = which to the top of the list

  int pop();
  // Pop off a front node from the list
  // Return success value of the pop.

  int top();
  // Returns _which of the top node.

  int empty();
  // Is the list empty?

  void initIterator();
  // Initialize _iterator
  // This method is used with getValue method

  int iteratorValue();
  // Returns _which of the node that _iterator is pointing to.

  void moveIterator();
  // make _iterator point to the next value

  int getNextValue();
  // Point _iterator to the next node and returns the _which of that node.
  // One can call this methods repeatly to get the _value of all the nodes.
  // However, initIterator has to be called before the initial call to this 
  // method.  
};

#endif

