//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon S. Lee (jl), Kee-Eung Kim (kek)   
//  FILE: PCRuleInvokeStmt.H
//  PROJ: COKO
//  DATE: 5/5/97                                                   
//
// SYNOPSIS
// Class definitions for CRuleInvokeStmt.
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef _PCRULEINVOKESTMT_H_
#define _PCRULEINVOKESTMT_H_

#include "PCStmt.H"
#include "PCRule.H"
#include "PCRuleBlock.H"

//////////////////////////////////////////////////////////////////////////////
//
//  CLASS: CRuleInvokeStmt
//
// SYNOPSIS
//  This class is a derived class from CStmt. It is used for rule
//  invoke statements in COKO rule block.
//
//////////////////////////////////////////////////////////////////////////////

class CRuleInvokeStmt : public CStmt {
protected:
  CRule *_first_r;         // It could be rule or rule block we are 
  CRuleBlock *_first_rb;   // invoking on.
  char * _second;          // The identifier name we are going to invoke with
public:
  CRuleInvokeStmt(CRule*, char *);       // Constructor for rule invoke
  CRuleInvokeStmt(CRuleBlock*, char *);  // Constructor for rule block invoke
  virtual ~CRuleInvokeStmt();            // Destructor
  CState *Exec(CState *);                // What to do when executed


  //DJA SUMMER 2001:
  //Added rep_string, representation, number_self, is_leaf and ExecDebug methods

  CState *ExecDebug(CState *, DDebugController *);
  // What to do when executed in debug mode
  char* rep_string ();
  //returns the string representation of only the current 
  //node of the COKO tree
  char* representation (int);
  //returns the string representation of the COKO subtree
  //using the currnet node as the root
  char* representationWDI(int, DDebugController *);
  //returns string representation of COKO tree
  //but also update the debugger with the location (row and
  //column) of each breakable statement's substring
  int number_self(int);
  //assigns an integer to the current node for use in the
  //debugger for the breakOptions command
  int is_leaf();
  //returns whether current statement is a leaf in the COKO tree
};

#endif
