/*
//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Mitch Cherniack (mfc@cs.brown.edu), Kee-Eung Kim (kek@cs.brown.edu) 
//        Joon S. Lee (jl@cs.brown.edu)
//  FILE: Coko.y
//  PROJ: COKO parser
//  DATE: 3/96                                                          
//
//////////////////////////////////////////////////////////////////////////////
*/ 

%token <sval> PIDENT FIDENT OIDENT BIDENT TIDENT IDENT STRINGCON INTCON FLOATCON
%token PDC FDC ODC BDC TDC BEG END RBLOCK ERROR GOESTO PRINT PRINTOQL PRINTSQL
%token LESS MORE LESSEQ MOREEQ
%token OPLUS CONST CURRY INV XTIMES TIMES EXISTS FORALL EX FA BAND BOR
%token INS SORT LSJOIN RSJOIN PEQUAL
%token ID SET ONE TWO SHIFTL SHIFTR CHOOSE FLATTEN 
%token CIRC PLUS MINUS CON UNI INT DIF PFOLD FOLD ITERATE ITER PCON JOIN  NJOIN UNNEST 
%token EMPTY NIL FINVOKE PINVOKE TRUEv FALSEv FADD FSUB FMUL FDIV SINGLETON TID
%token USES MATCH EACHCHILD THEN LANGLE RANGLE GIVEN DO REPEAT TD BU CURRTREE
%token DPO DPC KCHAR KSTRING KFLOAT OID
%token FMAX FMIN FCOUNT FSUM FAVG PLEX SKIP INTER ODIF NOT FINV ABS MOD MULT DIV IF FI ELSE FTHEN
%token OPREFIX FPREFIX PPREFIX BPREFIX 
/* EDDIE_SUMMER_00(took out PreCond, Conds, InfersClause, OptInfer) */
// Follow unique PROPERTY tokens
%token PROPERTY IMPL INFERS PERIOD
/*MARINA*/
%token PCOND

%right FINVOKE PINVOKE
%nonassoc GOESTO
%left ';'
%left OR 
%right THEN
%nonassoc TRUEv FALSEv TD BU
%nonassoc GIVEN
%nonassoc LOW
%nonassoc HIGH
%left '-' '+' ODIF
%left '*' '/'
%left UNION INTER XTIMES DIV MOD MULT TIMES PLUS MINUS CIRC OPLUS '&' '|' 
%left BOR BAND
%left FINV INV
%left PEQUAL LESS GREATER LE GE NE

/* EDDIE_SUMMER_00(took out: <PAS> PreCond , Conds ; <PAI> InfersClause OptInfer */
/* For property recognition */
%type <PARB> RuleBlock
%type <PAUL> Uses UseList 
%type <PAU> Use                                            /*MARINA*/
%type <PAS> Stmt MatchEachBody Eqn Eqns Fact VarList PreCond Conds
%type <PAB> Stmts 
%type <PAR> RuleP RuleF RuleO RuleB RulePBody RuleFBody RuleOBody RuleBBody
%type <PAP> Pred PrimP FormP Func PrimF FormF Obj PrimO FormO Bool PrimB FormB kType

%start RuleBlock

%{
#include <iostream.h>
#include <string.h>
#include "PAParser.h"
#include <algo.h>
#include <fstream.h>
#include <stdlib.h>

extern int lineno;
extern char *CKtext;

extern int CKlex ();
int CKerror(char *);

static char *buffer;
static int strlength;
static char *pl_buffer;
static int pl_strlength;
static PARuleTable theRuleTable;
static PAIdentTable theIdentTable;
static PAStack theStack;
static PAIdentSet theRRSet;
static PAIdentSet theRRTypeSet;
static PACode theDVList;
static int DCcount;
static int PCRcount;
static int Brec;
static char *RBname;
PARuleBlock *theBlock;
 PAIdentSet pr_includes;

/* For property stuff */
ofstream foutPR;


PARuleType determine_rule_type(PAIdentSet lhs, PAIdentSet rhs)
  {
    return RUNKNOWN;
  }
%}

%union {
  PARuleBlock *PARB;
  PAUseList *PAUL;
  PAUse *PAU;
  PABody *PAB;
  PARule *PAR;
  PAStmt *PAS;
  PAPattern *PAP;
  char *sval;
}


%%

/*********************************************************************************
   RuleBlock

   A rule block is a set of rules as well as a firing strategy for their
   use.  It corresponds conceptually to a "conceptual transformation";
   a transformation that is small enough to be considered a single
   transformation but large enough so as to be inexpressible with
   a single rule.

   A rule block is followed by a name, 
   optional "uses" declarations for rules and other rule blocks, and a main body.

**********************************************************************************/
  
RuleBlock       :  RBLOCK IDENT 

{ 
                       theRuleTable.insert(PARuleTable::value_type(string($2), RUNKNOWN));
                                           RBname = new char[strlen($2) + 1];
                                           strcpy(RBname, $2); 
                                           
                     } 

//EDDIE_SUMMER_00 Uses OptInfer BEG Stmts END
                   Uses OptInfer BEG Stmts END          /// Now needs fixing the $[0-7]? 
                     {
                       //DJA SUMMER 2001 added dat_mem, uses_code
                       PACode include, declarations, body, pbody, dat_mem, uses_code;

                       {
                         for(PACode::iterator i = $4->decl.begin(); i != $4->decl.end(); i++) {
                           strlength = strlen("#include \"") + strlen((*i).chars()) 
                             + strlen(".h\"") + 1;
                           buffer = new char[strlength];
                           sprintf(buffer, "#include \"%s.h\"", (*i).chars());
                           include.push_back(string(buffer));
                         }
                       }

                       // Marina Summer2001 - I modified this part of the .y file. When the include files are property files, KO need not
                       // be appended to the front. This code now compares the last letters of the file name to "Property". If it matches,
                       // the KO is not added, otherwise it is.

                                           {
                                           for(PAIdentSet::iterator i = theRRSet.begin(); i != theRRSet.end(); i++) {
                                            
                                                 strlength = strlen("#include \"KO") + strlen((*i).chars())
                                                   + strlen(".H\"") + 1;
                                                 buffer = new char[strlength];
                                                 sprintf(buffer, "#include \"KO%s.H\"", (*i).chars());
                                                 include.push_back(string(buffer));
                                                 
                                           }
                                           for(PAIdentSet::iterator i = pr_includes.begin();i!=pr_includes.end(); i++){
                                             strlength = strlen("#include \"") + strlen((*i).chars()) + strlen("\".h\"") + 1;
                                             buffer = new char[strlength];
                                             sprintf(buffer, "#include \"%s.h\"", (*i).chars());
                                             include.push_back(string(buffer));
                                           }
                                           
                                           }
                     

                       {
                                           for(PAIdentSet::iterator i = theRRTypeSet.begin(); i != theRRTypeSet.end(); i++) {
                                                 strlength = strlen("#include \"TY") + strlen((*i).chars())
                                                   + strlen(".H\"") + 1;
                                                 buffer = new char[strlength];
                                                 sprintf(buffer, "#include \"TY%s.H\"", (*i).chars());
                                                 include.push_back(string(buffer));
                                           }
                                           }

                                           {
                                             for(PACode::iterator i = $4->decl.begin(); i != $4->decl.end(); i++) {
                                               strlength = /*strlen("CRuleBlock * ") +*/ strlen((*i).chars())
                                                 + strlen(" = new CORB") + strlen((*i).chars()) + strlen(";") + 1;
                                               buffer = new char[strlength];
                                               sprintf(buffer, "%s = new CORB%s;", (*i).chars(), (*i).chars());
                                               declarations.push_back(string(buffer));
                                               strlength = strlen("CRuleBlock * ") + strlen((*i).chars()) + strlen(";") + 1;
                                               
                                               //ADDED DJA SUMMER 2001
                                               //Separating the delcaration of CRuleBlocks from their initialization.
                                               //This allows the initialaztion to occur in the construct_stmt method
                                               //which is used by the debugger in the EXPAND and CONTRACT
                                               delete [] buffer;
                                               buffer = new char[strlength];
                                               sprintf(buffer, "CRuleBlock * %s;", (*i).chars());
                                               dat_mem.push_back(string(buffer));
                                               
                                               //ADDED DJA SUMMER 2001
                                               //Adding RuleBlock into uses linked list
                                               //This is used by the representation method of the CRuleBlock class
                                               //to output the content of the USES section
                                               delete [] buffer;
                                               strlength = strlen("_useList->insert();") + strlen((*i).chars()) + 1;
                                               buffer = new char[strlength];
                                               sprintf(buffer, "_useList->insert(%s);", (*i).chars());
                                               uses_code.push_back(string(buffer));
                                             }
                                           }

                                           if (Brec) {
                                             strlength = /*strlen("CRuleBlock * ") + */strlen($2)
                                                   + strlen(" = new CORB") + strlen($2) + strlen(";") + 1;
                                                 buffer = new char[strlength];
                                                 sprintf(buffer, "%s = new CORB%s;", $2, $2);
                                                 declarations.push_back(string(buffer));
                                                 strlength = strlen("CRuleBlock * ") + strlen($2) + strlen(";") + 1;
                                               
                                                 //ADDED DJA SUMMER 2001
                                                 //Separating the delcaration of CRuleBlocks from their initialization.
                                                 //This allows the initialaztion to occur in the construct_stmt method
                                                 //which is used by the debugger in the EXPAND and CONTRACT
                                                 delete [] buffer;
                                                 buffer = new char[strlength];
                                                 sprintf(buffer, "CRuleBlock * %s;", $2);
                                                 dat_mem.push_back(string(buffer));
                                           }

                                           {
                                             for(PACode::iterator i = $4->code.begin(); i != $4->code.end(); i++) {
                                               
                                               //ADDED DJA SUMMER 2001
                                               //Separating the delcaration of CRules from their initialization.
                                               //This allows the initialaztion to occur in the construct_stmt method
                                               //which is used by the debugger in the EXPAND and CONTRACT
                                               const char* temp1 = i->chars();
                                               int len = strlen(temp1);
                                               //put into temp2 CRule * <name of rule>;
                                               //for example: "CRule * dist1;"
                                               //but first must extract the name of the rule from temp1
                                               //luckily we know that the name of the rule is the text before the '='
                                               if (len > 0) {
                                                 int j = 0;
                                                 while ((temp1[j] != '=') && j < (len))
                                                   j++;
                                                 char * temp2 = new char[j];
                                                 int k = 0;
                                                 while (k < j-1) {
                                                   temp2[k] = temp1[k];
                                                   k++;
                                                 }
                                                 temp2[k]='\0';
                                                 declarations.push_back(*i);
                                                 strlength = strlen("CRule * ") + strlen(temp2) + strlen(";") + /*strlen(temp1) + strlen(";") + */1;
                                                 buffer = new char[strlength];
                                                 sprintf(buffer, "CRule * %s;", temp2);
                                                 dat_mem.push_back(string(buffer));
                                               
                                                 //ADDED DJA SUMMER 2001
                                                 //Adding RuleBlock into uses linked list
                                                 //This is used by the representation method of the CRuleBlock class
                                                 //to output the content of the USES section
                                                 delete [] buffer;
                                                 strlength = strlen("_useList->insert();") + strlen(temp2) + 1;
                                                 buffer = new char[strlength];
                                                 sprintf(buffer, "_useList->insert(%s);", temp2);
                                                 uses_code.push_back(string(buffer));
                                                 delete [] temp2;
                                               }
                                             }
                                               
                                           }
                                           //dat_mem.push_back(string("CStmt * _rStmt_;"));
                                           declarations.push_back(string("_rStmt_ ="));
                                           copy($7->code.begin(), $7->code.end(), insert_iterator<PACode>(declarations, declarations.end()));
                                           declarations.push_back(string(";"));
                                           body.push_back(string("CState * new_s = _rStmt_->Exec(s);"));

                                           /* Code for cleaning things up */
                                           body.push_back(string("delete _rStmt_;"));
                                           body.push_back(string("delete _useList;"));
                                           body.push_back(string("_useList=NULL;"));
                                           {
                                           for(PARuleTable::iterator i = theRuleTable.begin(); i != theRuleTable.end(); i++) {
                                                 if(strcmp($2, (*i).first.chars()) == 0 && !Brec) continue; /* name for this block */
                                                 strlength = strlen("delete ") + strlen((*i).first.chars()) 
                                                   + strlen(";") + 1;
                                                 buffer = new char[strlength];
                                                 sprintf(buffer, "delete %s;", (*i).first.chars());
                                                 body.push_back(string(buffer));
                                           }
                                           }

                                           /* Code for cleaning things up */
                                           //dest.push_back(string("delete _rStmt_;"));
                                           //{
                                           //for(PARuleTable::iterator i = theRuleTable.begin(); i != theRuleTable.end(); i++) {
                                           //         if(strcmp($2, (*i).first.chars()) == 0 && !Brec) continue; /* name for this block */
                                           //         strlength = strlen("delete ") + strlen((*i).first.chars()) 
                                           //           + strlen(";") + 1;
                                           //         buffer = new char[strlength];
                                           //         sprintf(buffer, "delete %s;", (*i).first.chars());
                                           //         dest.push_back(string(buffer));
                                           // }
                                           // }
                                           body.push_back(string("return new_s;"));

                                           /*                                           {
                                                 fstream fout;
                                                 fout.open("fcompile_btr_schema.pl", ios::out);
                                                 fout << "?- fcompile('btr_schema.pl')." << endl << "?- halt." << endl;
                                                 fout.close();
                                                 
                                                 buffer = new char[strlen(RBname) + strlen("fcompile__fin.pl") + 1];
                                                 sprintf(buffer, "fcompile_%s_fin.pl",RBname);
                                                 fout.open(buffer, ios::out);
                                                 fout << "?- fcompile('" << RBname << "_fin.pl')." << endl << "?- halt." << endl;
                                                 fout.close();
                                                 if (buffer) {delete [] buffer; buffer = NULL;}
                                                 
                                                 pbody.push_back(string("?- use_module(library(charsio))."));
                                                 pbody.push_back(string("?- load('btr_schema.ql')."));
                                                 pbody.push_back(string($4->pcode.chars()));
                                                 
                                                 for(PACode::iterator i = $4->pcode.begin(); i != $4->pcode.end(); i++) 
                                                   pbody.push_back(*i); 
                                           }
                                           */
                                           //DJA SUMMER 2001 changed constructer for PARuleBlock to accept dat_mem and uses_code
                       $$ = theBlock = new PARuleBlock(string($2), include, dat_mem, uses_code, declarations, body, pbody);
                     }
                ;    

/********************************************************************************
                                                                                                                                                                 
   OptInfer
   
********************************************************************************/

//EDDIE_SUMMER_00

OptInfer        : INFERS InfersClause
                                 
                    {
                      /*          fstream fout;
                                     fout.open("fcompile_infers.pl", ios::app);
                                     fout << "?- halt." << endl;
                                     fout.close();
                                         
                                     int strlength = strlen("/pro/oodb/cokoc/prolog/sicstus3/inst_dir/bin/sicstus ") + strlen("-l ") 
                                           + strlen("fcompile_infers.pl") + 1;
                                     char* buffer = new char[strlength];
                                     strcpy(buffer, "/pro/oodb/cokoc/prolog/sicstus3/inst_dir/bin/sicstus -l fcompile_infers.pl");
                                     system(buffer);
                                     delete [] buffer;

                                     $$ = $3;        */
  
                                    }

                |

                    {
                      /* $$ = new PAInfer;
                         $$->pcode = string("");*/
                    }
                ;

/********************************************************************************

 InfersClause

********************************************************************************/

//EDDIE_SUMMER_00
InfersClause     :  InfersClause ',' IDENT

                     {
                            
                             pr_includes.insert(string($3));
                      
                                         }

                 |  IDENT

                    { pr_includes.insert(string($1));
                      
                                        }
                ;


/********************************************************************************
   Uses, UseList, Use
   
   Rule and rule block declaration section. Every rule must be proceeded by a name and ':'.
   All identifiers used in the Uses section must be distinct.
   
********************************************************************************/

Uses            :  USES UseList       

                    {$$ = $2; }

                |      
  
                    {$$ = new PAUseList; $$->code = PACode(); $$->decl = PACode();}
                ;

UseList         :  UseList ',' Use    

{
                      if(strlen($3->decl.chars()) != 0) $1->decl.push_back($3->decl.chars());
                      $1->code.push_back($3->code.chars());                  $$ = $1;
                      
                    }

                |  Use 

{ 
                      $$ = new PAUseList;
                      if(strlen($1->decl.chars()) != 0) $$->decl.push_back($1->decl.chars());
                      $$->code.push_back($1->code.chars());
                      
                    }

                ;

Use             :  IDENT ':' RuleF

                    {
                      //DJA SUMMER 2001 for each IDENT ':' RuleX (there are four) I took out the "CRule * " from the generated
                      //string because I needed to separate the delaration of the CRules from their initialization in the 
                      //construct_stmt method so that I can construct statements in advace for the debugger
                      $$ = new PAUse;
                      theRuleTable.insert(PARuleTable::value_type(string($1), $3->type));
        
                      //Marina Summer2001 due to the changes made for debugging purposes, a precondition rule was not being generated properly.
                      //A new field was added to PACode to specify if the rule was a precondition. The precondition code has also been moved up here
                      //to make it easier to write the debugger. If the rule has preconditions, the preconditional code is generated,
                      //otherwise the regule rule is generated.
                      if ($3->precond){
                        buffer = new char[strlen($1) + 4 + strlen("new CPreCondRule()")+strlen($3->code.chars())+1];
                        sprintf(buffer, "%s = new CPreCondRule(%s);", $1, $3->code.chars());
                        $$->code = string(buffer);
                        $$->decl = string("");
                      }
                      else{
                      
                      strlength = /*strlen("CRule * ") + */strlen($1) + strlen($1) + strlen(" = new CRule(, \"\")")
                        + strlen($3->code.chars()) + 2;
                      buffer = new char[strlength];
                      sprintf(buffer, "%s = new CRule(\"%s\", %s);", $1, $1, $3->code.chars());
                      $$->code = string(buffer);
                      $$->decl = string("");
                      }
                    }

                |  IDENT ':' RuleP

{
                      $$ = new PAUse;
                      theRuleTable.insert(PARuleTable::value_type(string($1), $3->type));
        
                      if ($3->precond){

                        buffer = new char[strlen($1) + 4 + strlen("new CPreCondRule()")+strlen($3->code.chars())+1];
                        sprintf(buffer, "%s = new CPreCondRule(%s);", $1, $3->code.chars());
                        $$->code = string(buffer);
                        $$->decl = string("");
                      }
                      else{
                      
                      strlength = /*strlen("CRule * ") + */strlen($1) + strlen($1) + strlen(" = new CRule(, \"\")")
                        + strlen($3->code.chars()) + 2;
                      buffer = new char[strlength];
                      sprintf(buffer, "%s = new CRule(\"%s\", %s);", $1, $1, $3->code.chars());
                      $$->code = string(buffer);
                      $$->decl = string("");
                      }
                    }

                 |  IDENT ':' RuleO
                                 
{
                      $$ = new PAUse;
                      theRuleTable.insert(PARuleTable::value_type(string($1), $3->type));
                      
                      if ($3->precond){

                        buffer = new char[strlen($1) + 4 +  strlen("new CPreCondRule()")+strlen($3->code.chars())+1];
                        sprintf(buffer, "%s = new CPreCondRule(%s);", $1, $3->code.chars());
                        $$->code = string(buffer);
                        $$->decl = string(""); 
                      }
                      else{
                        
                      strlength = /*strlen("CRule * ") + */strlen($1) + strlen($1) + strlen(" = new CRule(, \"\")")
                        + strlen($3->code.chars()) + 2;
                      
                      buffer = new char[strlength];
                      sprintf(buffer, "%s = new CRule(\"%s\", %s);", $1, $1,$3->code.chars());
 
                      $$->code = string(buffer);
                      $$->decl = string("");
                      }                      
                    }

                |  IDENT ':' RuleB

                    {
                      $$ = new PAUse;
                      theRuleTable.insert(PARuleTable::value_type(string($1), $3->type));
                      if ($3->precond){                        
                        buffer = new char[strlen($1) + 4 + strlen("new CPreCondRule()")+strlen($3->code.chars())+1];
                        sprintf(buffer, "%s = new CPreCondRule(%s);", $1, $3->code.chars());
                        $$->code = string(buffer);
                        $$->decl = string("");
                      }
                      else{
                      strlength = /*strlen("CRule * ") + */strlen($1) + strlen($1) + strlen(" = new CRule(, \"\")")
                        + strlen($3->code.chars()) + 2;
                      buffer = new char[strlength];
                      sprintf(buffer, "%s = new CRule(\"%s\", %s);", $1, $1, $3->code.chars());
                      $$->code = string(buffer);
                      $$->decl = string("");
                      }
                    }

                 |  IDENT 
                                 
                    {
                                  /* This is a call on external rule block */
                      $$ = new PAUse;
                      theRuleTable.insert(PARuleTable::value_type(string($1), RUNKNOWN));
                         
                                  strlength = strlen($1) + 1;
                      buffer = new char[strlength];
                                  strcpy(buffer, $1);
                      $$->code = string("");
                      $$->decl = string(buffer);
                    }

;



/********************************************************************************

                                                                                                                                                                 Stmt
   
********************************************************************************/

Stmt            :  IDENT    

                   { /* Rule firing stmt */
                     $$ = new PAStmt;
                     PARuleTable::iterator i;
                     if((i = theRuleTable.find(string($1))) != theRuleTable.end()) {
                       strlength = strlen("new CRuleInvokeStmt(") + strlen($1) 
                         + strlen(", NULL)") + 1;
                       buffer = new char[strlength];
                       sprintf(buffer, "new CRuleInvokeStmt(%s, NULL)", $1);
                       $$->code = string(buffer);
                                            if(strcmp(RBname, $1) == 0) Brec = 1;
                     }
                                         else { CKerror("No Such Rule"); $$->code = string(""); }
                                   }

                |  IDENT '(' FIDENT ')'

                    { /* Rule firing stmt with identifier */
                                         $$ = new PAStmt;
                                         PARuleTable::iterator i;
                                         PAIdentTable::iterator j;
                                         if((i = theRuleTable.find(string($1))) != theRuleTable.end()) {
                                           if((j = theIdentTable.find(string($3))) != theIdentTable.end()) {
                                                 strlength = strlen("new CRuleInvokeStmt(") + strlen($1) + strlen(", \"") 
                                                   + strlen($3) + strlen("\")") + 1;
                                                 buffer = new char[strlength];
                                                 sprintf(buffer, "new CRuleInvokeStmt(%s, \"%s\")", $1, $3);
                                                 $$->code = string(buffer);
                                                 if(strcmp(RBname, $1) == 0) Brec = 1;
                                           }
                                           else { CKerror("No Such Identifier"); $$->code = string(""); }
                                         }
                                         else { CKerror("No Such Rule"); $$->code = string(""); }
                                        }

                |  IDENT '(' PIDENT ')'

                    { /* Rule firing stmt with identifier */
                                         $$ = new PAStmt;
                                         PARuleTable::iterator i;
                                         PAIdentTable::iterator j;
                                         if((i = theRuleTable.find(string($1))) != theRuleTable.end()) {
                                           if((j = theIdentTable.find(string($3))) != theIdentTable.end()) {
                                                 strlength = strlen("new CRuleInvokeStmt(") + strlen($1) + strlen(", \"") 
                                                   + strlen($3) + strlen("\")") + 1;
                                                 buffer = new char[strlength];
                                                 sprintf(buffer, "new CRuleInvokeStmt(%s, \"%s\")", $1, $3);
                                                 $$->code = string(buffer);
                                                 if(strcmp(RBname, $1) == 0) Brec = 1;
                                           }
                                           else { CKerror("No Such Identifier"); $$->code= string(""); }
                                         }
                                         else { CKerror("No Such Rule"); $$->code= string(""); }
                                        }

                |  IDENT '(' OIDENT ')'

                    { /* Rule firing stmt with identifier */
                                          $$ = new PAStmt;
                                          PARuleTable::iterator i;
                                          PAIdentTable::iterator j;
                                          if((i = theRuleTable.find(string($1))) != theRuleTable.end()) {
                                                if((j = theIdentTable.find(string($3))) != theIdentTable.end()) {
                                                  strlength = strlen("new CRuleInvokeStmt(") + strlen($1) + strlen(", \"") 
                                                        + strlen($3) + strlen("\")") + 1;
                                                  buffer = new char[strlength];
                                                  sprintf(buffer, "new CRuleInvokeStmt(%s, \"%s\")", $1, $3);
                                                  $$->code = string(buffer);
                                                  if(strcmp(RBname, $1) == 0) Brec = 1;
                                                }
                                                else { CKerror("No Such Identifier"); $$->code = string(""); }
                                          }
                                          else { CKerror("No Such Rule"); $$->code = string(""); }
                                        }      
   
                |  IDENT '(' BIDENT ')'

                    { /* Rule firing stmt with identifier */
                                          $$ = new PAStmt;
                                          PARuleTable::iterator i;
                                          PAIdentTable::iterator j;
                                          if((i = theRuleTable.find(string($1))) != theRuleTable.end()) {
                                                if((j = theIdentTable.find(string($3))) != theIdentTable.end()) {
                                                  strlength = strlen("new CRuleInvokeStmt(") + strlen($1) + strlen(", \"") 
                                                        + strlen($3) + strlen("\")") + 1;
                                                  buffer = new char[strlength];
                                                  sprintf(buffer, "new CRuleInvokeStmt(%s, \"%s\")", $1, $3);
                                                  $$->code = string(buffer);
                                                  if(strcmp(RBname, $1) == 0) Brec = 1;
                                                }
                                                else { CKerror("No Such Identifier"); $$->code = string(""); }
                                          }
                                          else { CKerror("No Such Rule"); $$->code = string(""); }
                                        }

                |  '[' RuleF ']' '(' FIDENT ')'
 
                    {
                                          $$ = new PAStmt;
                                          PAIdentTable::iterator i;
                                          if((i = theIdentTable.find(string($5))) != theIdentTable.end()) {
                                                strlength = strlen("new CRuleInvokeStmt(") + strlen($2->code.chars()) 
                                                  + strlen(", \"") + strlen($5) + strlen("\")") + 1;
                                                buffer = new char[strlength];
                                                sprintf(buffer, "new CRuleInvokeStmt(%s, \"%s\")", $2->code.chars(), $5);
                                                $$->code = string(buffer);
                                          }
                                          else { CKerror("No Such Identifier"); $$->code = string(""); }
                                        }

                |  '[' RuleP ']' '(' PIDENT ')'
                                
                    {
                                          $$ = new PAStmt;
                                          PAIdentTable::iterator i;
                                          if((i = theIdentTable.find(string($5))) != theIdentTable.end()) {
                                                strlength = strlen("new CRuleInvokeStmt(") + strlen($2->code.chars()) 
                                                  + strlen(", \"") + strlen($5) + strlen("\")") + 1;
                                                buffer = new char[strlength];
                                                sprintf(buffer, "new CRuleInvokeStmt(%s, \"%s\")", $2->code.chars(), $5);
                                                $$->code = string(buffer);
                                          }
                                          else { CKerror("No Such Identifier"); $$->code = string(""); }
                                        }

                |  '[' RuleO ']' '(' OIDENT ')'

                    {
                                          $$ = new PAStmt;
                                          PAIdentTable::iterator i;
                                          if((i = theIdentTable.find(string($5))) != theIdentTable.end()) {
                                                strlength = strlen("new CRuleInvokeStmt(") + strlen($2->code.chars()) 
                                                  + strlen(", \"") + strlen($5) + strlen("\")") + 1;
                                                buffer = new char[strlength];
                                                sprintf(buffer, "new CRuleInvokeStmt(%s, \"%s\")", $2->code.chars(), $5);
                                                $$->code = string(buffer);
                                          }
                                          else { CKerror("No Such Identifier"); $$->code = string(""); }
                                        }      

                |  '[' RuleB ']' '(' BIDENT ')'
                                
                    {
                                          $$ = new PAStmt;
                                          PAIdentTable::iterator i;
                                          if((i = theIdentTable.find(string($5))) != theIdentTable.end()) {
                                                strlength = strlen("new CRuleInvokeStmt(") + strlen($2->code.chars()) 
                                                  + strlen(", \"") + strlen($5) + strlen("\")") + 1;
                                                buffer = new char[strlength];
                                                sprintf(buffer, "new CRuleInvokeStmt(%s, \"%s\")", $2->code.chars(), $5);
                                                $$->code = string(buffer);
                                          }
                                          else { CKerror("No Such Identifier"); $$->code = string(""); }
                                        }      
    
                |  '[' RuleF ']'

                    { 
                                          $$ = new PAStmt;
                                          /* Rule firing stmt */
                                          strlength = strlen("new CRuleInvokeStmt(") + strlen($2->code.chars()) 
                                                + strlen(", NULL)") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new CRuleInvokeStmt(%s, NULL)", $2->code.chars());
                                          $$->code = string(buffer);
                                        }

                |  '[' RuleP ']'

                    { 
                                          $$ = new PAStmt;
                                          /* Rule firing stmt */
                                          strlength = strlen("new CRuleInvokeStmt(") + strlen($2->code.chars()) 
                                                + strlen(", NULL)") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new CRuleInvokeStmt(%s, NULL)", $2->code.chars());
                                          $$->code = string(buffer);
                                        }

                |  '[' RuleO ']'

                    { 
                                          $$ = new PAStmt;
                                          /* Rule firing stmt */
                                          strlength = strlen("new CRuleInvokeStmt(") + strlen($2->code.chars()) 
                                                + strlen(", NULL)") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new CRuleInvokeStmt(%s, NULL)", $2->code.chars());
                                          $$->code = string(buffer);
                                        }

                |  '[' RuleB ']'

                    { 
                                          $$ = new PAStmt;
                                          /* Rule firing stmt */
                                          strlength = strlen("new CRuleInvokeStmt(") + strlen($2->code.chars()) 
                                                + strlen(", NULL)") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new CRuleInvokeStmt(%s, NULL)", $2->code.chars());
                                          $$->code = string(buffer);
                                        }

                |  IDENT INV '(' FIDENT ')'

                    {
                                          $$ = new PAStmt;
                                          PARuleTable::iterator i;
                                          PAIdentTable::iterator j;
                                          if((i = theRuleTable.find(string($1))) != theRuleTable.end()) {
                                                if((j = theIdentTable.find(string($4))) != theIdentTable.end()) {
                                                  if((*i).second != RMORE_LEFT) {
                                                        strlength = strlen("new CRuleInvInvokeStmt(") + strlen($1) + strlen(", \"") 
                                                          + strlen($4) + strlen("\")") + 1;
                                                        buffer = new char[strlength];
                                                        sprintf(buffer, "new CRuleInvInvokeStmt(%s, \"%s\")", $1, $4);
                                                        $$->code = string(buffer);
                                                        if(strcmp(RBname, $1) == 0) Brec = 1;
                                                  }
                                                  else { CKerror("Inv Impossible"); $$->code = string(""); }
                                                }
                                                else { CKerror("No Such Identifier"); $$->code = string(""); }
                                          }
                                          else { CKerror("No Such Rule"); $$->code = string(""); }
                                        }

                |  IDENT INV '(' PIDENT ')'
                                
                    {
                                          $$ = new PAStmt;
                                          PARuleTable::iterator i;
                                          PAIdentTable::iterator j;
                                          if((i = theRuleTable.find(string($1))) != theRuleTable.end()) {
                                                if((j = theIdentTable.find(string($4))) != theIdentTable.end()) {
                                                  if((*i).second != RMORE_LEFT) {
                                                        strlength = strlen("new CRuleInvInvokeStmt(") + strlen($1) + strlen(", \"") 
                                                          + strlen($4) + strlen("\")") + 1;
                                                        buffer = new char[strlength];
                                                        sprintf(buffer, "new CRuleInvInvokeStmt(%s, \"%s\")", $1, $4);
                                                        $$->code = string(buffer);
                                                        if(strcmp(RBname, $1) == 0) Brec = 1;
                                                  }
                                                  else { CKerror("Inv Impossible"); $$->code = string(""); }
                                                }
                                                else { CKerror("No Such Identifier"); $$->code = string(""); }
                                          }
                                          else { CKerror("No Such Rule"); $$->code = string(""); }
                                        }

                |  IDENT INV '(' OIDENT ')'

                    {
                                          $$ = new PAStmt;
                                          PARuleTable::iterator i;
                                          PAIdentTable::iterator j;
                                          if((i = theRuleTable.find(string($1))) != theRuleTable.end()) {
                                                if((j = theIdentTable.find(string($4))) != theIdentTable.end()) {
                                                  if((*i).second != RMORE_LEFT) {
                                                        strlength = strlen("new CRuleInvInvokeStmt(") + strlen($1) + strlen(", \"") 
                                                          + strlen($4) + strlen("\")") + 1;
                                                        buffer = new char[strlength];
                                                        sprintf(buffer, "new CRuleInvInvokeStmt(%s, \"%s\")", $1, $4);
                                                        $$->code = string(buffer);
                                                        if(strcmp(RBname, $1) == 0) Brec = 1;
                                                  }
                                                  else { CKerror("Inv Impossible"); $$->code = string(""); }
                                                }
                                                else { CKerror("No Such Identifier"); $$->code = string(""); }
                                          }
                                          else { CKerror("No Such Rule"); $$->code = string(""); }
                                        }      

                |  IDENT INV '(' BIDENT ')'
                                
                    {
                                          $$ = new PAStmt;
                                          PARuleTable::iterator i;
                                          PAIdentTable::iterator j;
                                          if((i = theRuleTable.find(string($1))) != theRuleTable.end()) {
                                                if((j = theIdentTable.find(string($4))) != theIdentTable.end()) {
                                                  if((*i).second != RMORE_LEFT) {
                                                        strlength = strlen("new CRuleInvInvokeStmt(") + strlen($1) + strlen(", \"") 
                                                          + strlen($4) + strlen("\")") + 1;
                                                        buffer = new char[strlength];
                                                        sprintf(buffer, "new CRuleInvInvokeStmt(%s, \"%s\")", $1, $4);
                                                        $$->code = string(buffer);
                                                        if(strcmp(RBname, $1) == 0) Brec = 1;
                                                  }
                                                  else { CKerror("Inv Impossible"); $$->code = string(""); }
                                                }
                                                else { CKerror("No Such Identifier"); $$->code = string(""); }
                                          }
                                          else { CKerror("No Such Rule"); $$->code = string(""); }
                                        }

                |  IDENT INV

                    { /* Rule firing stmt */
                                          $$ = new PAStmt;
                                          PARuleTable::iterator i;
                                          if((i = theRuleTable.find(string($1))) != theRuleTable.end()) {
                                                if((*i).second != RMORE_LEFT) {
                                                  strlength = strlen("new CRuleInvInvokeStmt(") + strlen($1) 
                                                        + strlen(", NULL)") + 1;
                                                  buffer = new char[strlength];
                                                  sprintf(buffer, "new CRuleInvInvokeStmt(%s, NULL)", $1);
                                                  $$->code = string(buffer);
                                                  if(strcmp(RBname, $1) == 0) Brec = 1;
                                                }
                                                else { CKerror("Inv Impossible"); $$->code = string(""); }
                                          }
                                          else { CKerror("No Such Rule"); $$->code = string(""); }
                                        }

                |  PRINT BIDENT
                           
                    {
                                          $$ = new PAStmt;
                                          PAIdentTable::iterator j;
                                          if ((j = theIdentTable.find(string($2))) != theIdentTable.end()) {
                                                strlength = strlen("new CPrintStmt(")  + strlen("1, ") + strlen("\"") + strlen($2) + strlen("\")") + 1;
                                                buffer = new char[strlength];
                                                sprintf(buffer, "new CPrintStmt(1, \"%s\")", $2);
                                                $$->code = string(buffer);
                                          }
                                          else { CKerror("No Such Identifier"); $$->code = string(""); }
                                        }

                |  PRINT FIDENT
                          
                    { 
                                          $$ = new PAStmt;
                                          PAIdentTable::iterator j;
                                          if ((j = theIdentTable.find(string($2))) != theIdentTable.end()) {
                                                strlength = strlen("new CPrintStmt(")  + strlen("1, ") + strlen("\"") + strlen($2) + strlen("\")") + 1;
                                                buffer = new char[strlength];
                                                sprintf(buffer, "new CPrintStmt(1, \"%s\")", $2);
                                                $$->code = string(buffer);
                                          }
                                          else { CKerror("No Such Identifier"); $$->code = string(""); }
                                        }      

                |  PRINT OIDENT
                          
                    {
                                          $$ = new PAStmt;
                                          PAIdentTable::iterator j;
                                          if ((j = theIdentTable.find(string($2))) != theIdentTable.end()) {
                                                strlength = strlen("new CPrintStmt(") + strlen("1, ") + strlen("\"") + strlen($2) + strlen("\")") + 1;
                                                buffer = new char[strlength];
                                                sprintf(buffer, "new CPrintStmt(1, \"%s\")", $2);
                                                $$->code = string(buffer);
                                          }
                                          else { CKerror("No Such Identifier"); $$->code = string(""); }
                                        }      

                |  PRINT PIDENT
                          
                    {
                                          $$ = new PAStmt;
                                          PAIdentTable::iterator j;
                                          if ((j = theIdentTable.find(string($2))) != theIdentTable.end()) {
                                                strlength = strlen("new CPrintStmt(") + strlen("1, ") + strlen("\"") + strlen($2) + strlen("\")") + 1;
                                                buffer = new char[strlength];
                                                sprintf(buffer, "new CPrintStmt(1, \"%s\")", $2);
                                                $$->code = string(buffer);
                                          }
                                          else { CKerror("No Such Identifier"); $$->code = string(""); }
                                        }

                |  PRINT STRINGCON
                          
                    {
                                          $$ = new PAStmt;
                                          strlength = strlen("new CPrintStmt(") + strlen("2, ") + strlen($2) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new CPrintStmt(2, %s)", $2);
                                          $$->code = string(buffer);
                                        }

                |  PRINT CURRTREE
                          
                    {
                                         $$ = new PAStmt;
                                         strlength = strlen("new CPrintStmt(") + strlen("3, ") + strlen("NULL)") + 1;
                                         buffer = new char[strlength];
                                         sprintf(buffer, "new CPrintStmt(3, NULL)");
                                         $$->code = string(buffer);
                                   }

                |  PRINTOQL BIDENT
                          
                   {
                                         $$ = new PAStmt;
                                         PAIdentTable::iterator j;
                                         if ((j = theIdentTable.find(string($2))) != theIdentTable.end()) {
                                           strlength = strlen("new COQPrintStmt(")  + strlen("2, ") + strlen("\"") + strlen($2) + strlen("\")") + 1;
                                           buffer = new char[strlength];
                                           sprintf(buffer, "new COQPrintStmt(2, \"%s\")", $2);
                                           $$->code = string(buffer);
                                         }
                                         else { CKerror("No Such Identifier"); $$->code = string(""); }
                                   }

                |  PRINTOQL OIDENT
                         
                   {
                                         $$ = new PAStmt;
                                         PAIdentTable::iterator j;
                                         if ((j = theIdentTable.find(string($2))) != theIdentTable.end()) {
                                           strlength = strlen("new COQPrintStmt(") + strlen("1, ") + strlen("\"") + strlen($2) + strlen("\")") + 1;
                                           buffer = new char[strlength];
                                           sprintf(buffer, "new COQPrintStmt(1, \"%s\")", $2);
                                           $$->code = string(buffer);
                                         }
                                         else { CKerror("No Such Identifier"); $$->code = string(""); }
                                   }      

                |  PRINTOQL CURRTREE
                         
                    {
                                         $$ = new PAStmt;
                                         strlength = strlen("new COQPrintStmt(") + strlen("3, ") + strlen("NULL)") + 1;
                                         buffer = new char[strlength];
                                         sprintf(buffer, "new COQPrintStmt(3, NULL)");
                                         $$->code = string(buffer);
                                   }

                |  PRINTSQL BIDENT
                          
                   {
                                         $$ = new PAStmt;
                                         PAIdentTable::iterator j;
                                         if ((j = theIdentTable.find(string($2))) != theIdentTable.end()) {
                                           strlength = strlen("new CSQPrintStmt(")  + strlen("2, ") + strlen("\"") + strlen($2) + strlen("\")") + 1;
                                           buffer = new char[strlength];
                                           sprintf(buffer, "new CSQPrintStmt(2, \"%s\")", $2);
                                           $$->code = string(buffer);
                                         }
                                         else { CKerror("No Such Identifier"); $$->code = string(""); }
                                   }

                |  PRINTSQL OIDENT
                         
                   {
                                         $$ = new PAStmt;
                                         PAIdentTable::iterator j;
                                         if ((j = theIdentTable.find(string($2))) != theIdentTable.end()) {
                                           strlength = strlen("new CSQPrintStmt(") + strlen("1, ") + strlen("\"") + strlen($2) + strlen("\")") + 1;
                                           buffer = new char[strlength];
                                           sprintf(buffer, "new CSQPrintStmt(1, \"%s\")", $2);
                                           $$->code = string(buffer);
                                         }
                                         else { CKerror("No Such Identifier"); $$->code = string(""); }
                                   }      

                |  PRINTSQL CURRTREE
                         
                    {
                                         $$ = new PAStmt;
                                         strlength = strlen("new CSQPrintStmt(") + strlen("3, ") + strlen("NULL)") + 1;
                                         buffer = new char[strlength];
                                         sprintf(buffer, "new CSQPrintStmt(3, NULL)");
                                         $$->code = string(buffer);
                                   }

        |  MATCH EACHCHILD {  theStack.push(theIdentTable); } MatchEachBody            
                         
                   { $$ = $4; }


                |  GIVEN { theStack.push(theIdentTable); } Eqns DO Stmt 
                         
                  {
                                        $$ = new PAStmt;  
                                        strlength = strlen("new CGivenStmt(") + strlen($5->code.chars()) + strlen(", ") + strlen($3->code.chars())   
                                          + strlen(", NULL") + strlen(")") + 1;  
                                        buffer = new char[strlength];  
                                        sprintf(buffer, "new CGivenStmt(%s, %s, NULL)", $5->code.chars(), $3->code.chars());  
                                        $$->code = string(buffer);  
                                        theIdentTable = theStack.top();  
                                        theStack.pop();  
                                  }

                |  TRUEv Stmt 

                    {
                                        $$ = new PAStmt;
                                        strlength = strlen("new CTrueStmt(") + strlen($2->code.chars()) + strlen(")") + 1;
                                        buffer = new char[strlength];
                                        sprintf(buffer, "new CTrueStmt(%s)", $2->code.chars());
                                        $$->code = string(buffer);
                                  }

                |  FALSEv Stmt

                    {
                                          $$ = new PAStmt;
                                          strlength = strlen("new CFalseStmt(") + strlen($2->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new CFalseStmt(%s)", $2->code.chars());
                                          $$->code = string(buffer);
                                        }

                |  REPEAT Stmt

                    {
                                          $$ = new PAStmt;
                                          strlength = strlen("new CRepeatStmt(") + strlen($2->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new CRepeatStmt(%s)", $2->code.chars());
                                          $$->code = string(buffer);
                                        }

                |  TD Stmt

                    {
                                          $$ = new PAStmt;
                                          strlength = strlen("new CTopDownStmt(") + strlen($2->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new CTopDownStmt(%s)", $2->code.chars());
                                          $$->code = string(buffer);
                                        }

                |  BU Stmt

                    {
                                          $$ = new PAStmt;
                                          strlength = strlen("new CBottomUpStmt(") + strlen($2->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new CBottomUpStmt(%s)", $2->code.chars());
                                          $$->code = string(buffer);
                                        }

                |  SKIP

                    {
                                          $$ = new PAStmt;
                                          strlength = strlen("new CSkipStmt()") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new CSkipStmt()");
                                          $$->code = string(buffer);
                                        }

                |  '{' Stmts '}' 

                    {
                                          $$ = new PAStmt;
                                          PACode::iterator i;
                                          char *oldbuffer;
                                          
                                          for(buffer = NULL, i = $2->code.begin(); i != $2->code.end(); i++) {
                                                oldbuffer = buffer;
                                                strlength = ((oldbuffer == NULL)? 0 : strlen(oldbuffer)) + strlen((*i).chars()) + 1;
                                                buffer = new char[strlength];
                                                if(oldbuffer == NULL) buffer[0] = '\0'; 
                                                else strcpy(buffer, oldbuffer);
                                                strcat(buffer, (*i).chars());
                                                if(oldbuffer != NULL) delete oldbuffer;
                                          }
                                          $$->code = string(buffer);
                                        }

               ;

Eqns           :  Eqn ',' Eqns     %prec HIGH

                    {
                                          $$ = new PAStmt; 
                                          int strlength = strlen($1->code.chars()) + strlen(", ") + strlen($3->code.chars()) + 1; 
                                          buffer = new char[strlength]; 
                                          sprintf(buffer, "%s, %s", $1->code.chars(), $3->code.chars()); 
                                          $$->code = string(buffer); 
                                        }

               |  Eqn              %prec LOW
                         
                    {
                                          $$ = $1;
                                        }

               ;

Eqn            :  FIDENT PEQUAL Func

                    {
                                          $$ = new PAStmt; 
                                          PACode::iterator i; 
                                          PAIdentTable::iterator j; 
                                          if ((j = theIdentTable.find(string($1))) != theIdentTable.end()) 
                                                { 
                                                  DEPSet theSet; 
                                                  PAPair thePair; 
                                                  int varLengthCount = 0; 
                                                  int varNumCount = 0; 
                                                  for (i = theDVList.begin(); i != theDVList.end(); i++) 
                                                        { 
                                                          theSet.insert((*i).chars()); 
                                                          varNumCount++; 
                                                          varLengthCount += strlen((*i).chars()); 
                                                        } 
                                                  thePair.first = theSet; 
                                                  thePair.second = FUNC; 
                                                  theIdentTable.insert(PAIdentTable::value_type(string($1),thePair)); 
                                                  strlength = strlen("new CEqn(") + strlen("\"") + strlen($1) +  strlen("\"") + strlen(", ") 
                                                        + strlen("new CPattern(") + strlen($3->code.chars()) + strlen(")") + strlen(")") + 1;
                                                  buffer = new char[strlength]; 
                                                  sprintf(buffer, "new CEqn(\"%s\", new CPattern(%s))", $1, $3->code.chars()); 
                                                  $$->code = string(buffer); 
                                                } 
                                          else 
                                                {CKerror("Variable Not Initialized - redefine uninitialized variable error"); $$->code = string("");}
                                        }


                |  PIDENT PEQUAL Pred
                         
                    {
                                          $$ = new PAStmt; 
                                          PACode::iterator i; 
                                          PAIdentTable::iterator j; 
                                          if ((j = theIdentTable.find(string($1))) != theIdentTable.end()) 
                                                { 
                                                  DEPSet theSet; 
                                                  PAPair thePair; 
                                                  int varLengthCount = 0; 
                                                  int varNumCount = 0; 
                                                  for (i = theDVList.begin(); i != theDVList.end(); i++) 
                                                        { 
                                                          theSet.insert((*i).chars()); 
                                                          varNumCount++; 
                                                          varLengthCount += strlen((*i).chars()); 
                                                        } 
                                                  thePair.first = theSet; 
                                                  thePair.second = FUNC; 
                                                  theIdentTable.insert(PAIdentTable::value_type(string($1),thePair)); 
                                                  strlength = strlen("new CEqn(") + strlen("\"")  + strlen($1) + strlen("\"")  + strlen(", ") 
                                                        + strlen("new CPattern(") + strlen($3->code.chars()) + strlen(")") + strlen(")") + 1; 
                                                  buffer = new char[strlength]; 
                                                  sprintf(buffer, "new CEqn(\"%s\", new CPattern(%s))", $1, $3->code.chars()); 
                                                  $$->code = string(buffer); 
                                                } 
                                          else 
                                                {CKerror("Variable Not Initialized - redefine uninitialized variable error"); $$->code = string("");}
                                        }

                |  OIDENT PEQUAL Obj 

                    {
                                          $$ = new PAStmt; 
                                          PACode::iterator i; 
                                          PAIdentTable::iterator j; 
                                          if ((j = theIdentTable.find(string($1))) != theIdentTable.end()) 
                                                { 
                                                  DEPSet theSet; 
                                                  PAPair thePair; 
                                                  int varLengthCount = 0; 
                                                  int varNumCount = 0; 
                                                  for (i = theDVList.begin(); i != theDVList.end(); i++) 
                                                        { 
                                                          theSet.insert((*i).chars()); 
                                                          varNumCount++; 
                                                          varLengthCount += strlen((*i).chars()); 
                                                        } 
                                                  thePair.first = theSet; 
                                                  thePair.second = FUNC; 
                                                  theIdentTable.insert(PAIdentTable::value_type(string($1),thePair)); 
                                                  strlength = strlen("new CEqn(")  + strlen("\"") + strlen($1) + strlen("\"") + strlen(", ") 
                                                        + strlen("new CPattern(") + strlen($3->code.chars()) + strlen(")") + strlen(")") + 1; 
                                                  buffer = new char[strlength]; 
                                                  sprintf(buffer, "new CEqn(\"%s\", new CPattern(%s))", $1, $3->code.chars()); 
                                                  $$->code = string(buffer); 
                                                } 
                                          else 
                                                {CKerror("Variable Not Initialized - redefine uninitialized variable error"); $$->code = string("");} 
                                        }

                |  BIDENT PEQUAL Bool
                        
                    {
                                          $$ = new PAStmt; 
                                          PACode::iterator i; 
                                          PAIdentTable::iterator j; 
                                          if ((j = theIdentTable.find(string($1))) != theIdentTable.end()) 
                                                { 
                                                  DEPSet theSet; 
                                                  PAPair thePair; 
                                                  int varLengthCount = 0; 
                                                  int varNumCount = 0; 
                                                  for (i = theDVList.begin(); i != theDVList.end(); i++) 
                                                        { 
                                                          theSet.insert((*i).chars()); 
                                                          varNumCount++; 
                                                          varLengthCount += strlen((*i).chars()); 
                                                        } 
                                                  thePair.first = theSet; 
                                                  thePair.second = FUNC; 
                                                  theIdentTable.insert(PAIdentTable::value_type(string($1),thePair)); 
                                                  strlength = strlen("new CEqn(")  + strlen("\"") + strlen($1)  + strlen("\"") + strlen(", ") 
                                                        + strlen("new CPattern(") + strlen($3->code.chars()) + strlen(")") + strlen(")") + 1; 
                                                  buffer = new char[strlength]; 
                                                  sprintf(buffer, "new CEqn(\"%s\", new CPattern(%s))", $1, $3->code.chars()); 
                                                  $$->code = string(buffer); 
                                                } 
                                          else 
                                                {CKerror("Variable Not Initialized - redefine uninitialized variable error"); $$->code = string("");} 
                                        }

                |  Func

                    {
                                          $$ = new PAStmt; 
                                          PACode::iterator i; 
                                          PAIdentTable::iterator j; 
                                          DEPSet theSet; 
                                          PAPair thePair; 
                                          int varLengthCount = 0; 
                                          int varNumCount = 0; 
                                          for (i = theDVList.begin(); i != theDVList.end(); i++) 
                                                { 
                                                  theSet.insert((*i).chars()); 
                                                  varNumCount++; 
                                                  varLengthCount += strlen((*i).chars()); 
                                                } 
                                          thePair.first = theSet; 
                                          thePair.second = FUNC; 
                                          theIdentTable.insert(PAIdentTable::value_type(string("curr"),thePair)); 
                                          strlength = strlen("new CEqn(") + strlen("NULL") + strlen(", ") 
                                                + strlen("new CPattern(") + strlen($1->code.chars()) + strlen(")") + strlen(")") + 1; 
                                          buffer = new char[strlength]; 
                                          sprintf(buffer, "new CEqn(NULL, new CPattern(%s))", $1->code.chars()); 
                                          $$->code = string(buffer); 
                                        }

                |  Pred

                    {
                                          $$ = new PAStmt; 
                                          PACode::iterator i; 
                                          PAIdentTable::iterator j; 
                                          DEPSet theSet; 
                                          PAPair thePair; 
                                          int varLengthCount = 0; 
                                          int varNumCount = 0; 
                                          for (i = theDVList.begin(); i != theDVList.end(); i++) 
                                                { 
                                                  theSet.insert((*i).chars()); 
                                                  varNumCount++; 
                                                  varLengthCount += strlen((*i).chars()); 
                                                } 
                                          thePair.first = theSet; 
                                          thePair.second = FUNC; 
                                          theIdentTable.insert(PAIdentTable::value_type(string("curr"),thePair)); 
                                          strlength = strlen("new CEqn(") + strlen("NULL") + strlen(", ") 
                                                + strlen("new CPattern(") + strlen($1->code.chars()) + strlen(")") + strlen(")") + 1; 
                                          buffer = new char[strlength]; 
                                          sprintf(buffer, "new CEqn(NULL, new CPattern(%s))", $1->code.chars()); 
                                          $$->code = string(buffer); 
                                        } 

                |  Obj

                    {
                                          $$ = new PAStmt; 
                                          PACode::iterator i; 
                                          PAIdentTable::iterator j; 
                                          DEPSet theSet; 
                                          PAPair thePair; 
                                          int varLengthCount = 0; 
                                          int varNumCount = 0; 
                                          for (i = theDVList.begin(); i != theDVList.end(); i++) 
                                                { 
                                                  theSet.insert((*i).chars()); 
                                                  varNumCount++; 
                                                  varLengthCount += strlen((*i).chars()); 
                                                } 
                                          thePair.first = theSet; 
                                          thePair.second = FUNC; 
                                          theIdentTable.insert(PAIdentTable::value_type(string("curr"),thePair)); 
                                          strlength = strlen("new CEqn(") + strlen("NULL") + strlen(", ") 
                                                + strlen("new CPattern(") + strlen($1->code.chars()) + strlen(")") + strlen(")") + 1; 
                                          buffer = new char[strlength]; 
                                          sprintf(buffer, "new CEqn(NULL, new CPattern(%s))", $1->code.chars()); 
                                          $$->code = string(buffer); 
                                        }

                |  Bool

                    {
                                          $$ = new PAStmt; 
                                          PACode::iterator i; 
                                          PAIdentTable::iterator j; 
                                          DEPSet theSet; 
                                          PAPair thePair; 
                                          int varLengthCount = 0; 
                                          int varNumCount = 0; 
                                          for (i = theDVList.begin(); i != theDVList.end(); i++) 
                                                { 
                                                  theSet.insert((*i).chars()); 
                                                  varNumCount++; 
                                                  varLengthCount += strlen((*i).chars()); 
                                                } 
                                          thePair.first = theSet; 
                                          thePair.second = FUNC; 
                                          theIdentTable.insert(PAIdentTable::value_type(string("curr"),thePair)); 
                                          strlength = strlen("new CEqn(") + strlen("NULL") + strlen(", ") 
                                                + strlen("new CPattern(") + strlen($1->code.chars()) + strlen(")") + strlen(")") + 1; 
                                          buffer = new char[strlength]; 
                                          sprintf(buffer, "new CEqn(NULL, new CPattern(%s))", $1->code.chars()); 
                                          $$->code = string(buffer); 
                                        }

               ;

MatchEachBody  :  FIDENT 

                    {
                                          PAPair thePair;
                                          thePair.second = FUNC;
                                          theIdentTable.insert(PAIdentTable::value_type(string($1), thePair)); 
                                        } 

                    THEN Stmt
                                
                    {
                                          $$ = new PAStmt;
                                          strlength = strlen("new CMatchEachStmt(new CChildPattern(new FVar(\"") + strlen($1)
                                                + strlen("\")), ") + strlen($4->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new CMatchEachStmt(new CChildPattern(new FVar(\"%s\")), %s)", $1, $4->code.chars());
                                          $$->code = string(buffer);
                                          theIdentTable = theStack.top();
                                          theStack.pop();
                                        }

                |  PIDENT 

                    { 
                                          PAPair thePair;
                                          thePair.second = PRED;
                                          theIdentTable.insert(PAIdentTable::value_type(string($1), thePair)); 
                                        } 

                    THEN Stmt
 
                    {
                                          $$ = new PAStmt;
                                          strlength = strlen("new CMatchEachStmt(new CChildPattern(new PVar(\"") + strlen($1)
                                                + strlen("\")), ") + strlen($4->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new CMatchEachStmt(new CChildPattern(new PVar(\"%s\")), %s)", $1, $4->code.chars());
                                          $$->code = string(buffer);
                                          theIdentTable = theStack.top();
                                          theStack.pop();
                                        }

                |  OIDENT 
                   
                    { 
                                          PAPair thePair;
                                          thePair.second = OBJ;
                                          theIdentTable.insert(PAIdentTable::value_type(string($1), thePair)); 
                                        }

                    THEN Stmt
                                
                    {
                                          $$ = new PAStmt;
                                          strlength = strlen("new CMatchEachStmt(new CChildPattern(new OVar(\"") + strlen($1)
                                                + strlen("\")), ") + strlen($4->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new CMatchStmt(new CChildPattern(new OVar(\"%s\")), %s)", $1, $4->code.chars());
                                          $$->code = string(buffer);
                                          theIdentTable = theStack.top();
                                          theStack.pop();
                                        }

                |  BIDENT 

                    { 
                                          PAPair thePair;
                                          thePair.second = BOOL;
                                          theIdentTable.insert(PAIdentTable::value_type(string($1), thePair)); 
                                        } 

                    THEN Stmt 
 
                    {
                                          $$ = new PAStmt;
                                          strlength = strlen("new CMatchEachStmt(new CChildPattern(new BVar(\"") + strlen($1)
                                                + strlen("\")), ") + strlen($4->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new CMatchEachStmt(new CChildPattern(new BVar(\"%s\")), %s)", $1, $4->code.chars());
                                          $$->code = string(buffer);
                                          theIdentTable = theStack.top();
                                          theStack.pop();
                                        }

                ;

Stmts           : Stmts ';' Stmt     %prec ';'

                    {
                                          $$ = new PABody;
                                          $1->code.push_front(string("new CMulStmtSeq("));
                                          $1->code.push_back(string(","));
                                          $1->code.push_back(string($3->code.chars()));
                                          $1->code.push_back(string(")"));
                                          $$ = $1;
                                        }

                |  Stmts OR Stmt     %prec OR

                    {
                                          $$ = new PABody;
                                          $1->code.push_front(string("new CMulStmtDis("));
                                          $1->code.push_back(string(","));
                                          $1->code.push_back(string($3->code.chars()));
                                          $1->code.push_back(string(")"));
                                          $$ = $1;
                                        }

                |  Stmts THEN Stmt     %prec THEN

                    {
                                          $$ = new PABody;
                                          $1->code.push_front(string("new CMulStmtCon("));
                                          $1->code.push_back(string(","));
                                          $1->code.push_back(string($3->code.chars()));
                                          $1->code.push_back(string(")"));
                                          $$ = $1;
                                        } 
                   
                |  Stmt

                    {
                                          $$ = new PABody;
                                          $$->code.push_back(string($1->code.chars()));
                                        }

                ;


/********************************************************************************
 ********************************************************************************
 
   PreCond
   
********************************************************************************
********************************************************************************/

PreCond         : Conds PCOND

                   {
                                         $$ = new PAStmt;
                                         int strlength = strlen("new CPreCond(") + strlen("\"") + strlen(RBname) + 
                                           strlen("\"") + strlen(", ") + strlen($1->code.chars()) + strlen(", NULL)   ") + 6;
                                         buffer = new char[strlength]; 
                                         sprintf(buffer, "new CPreCond(\"%s\", %s, NULL   )", RBname, $1->code.chars()); 
                                         PCRcount++;
                                         $$->code = string(buffer); 
                                   }
                 
                ;

Conds           : Conds ',' Fact

                   {
                                         $$ = new PAStmt; 
                                         int strlength = strlen($1->code.chars()) + strlen(", ") + strlen($3->code.chars()) + 1; 
                                         buffer = new char[strlength]; 
                                         sprintf(buffer, "%s, %s", $1->code.chars(), $3->code.chars()); 
                                         $$->code = string(buffer); 
                                         
                                        
                                   
                                   }

                |  Fact
                        
                    {
                                          $$ = new PAStmt; 
                                          int strlength = strlen($1->code.chars()) + 1; 
                                          buffer = new char[strlength]; 
                                          sprintf(buffer, "%s", $1->code.chars()); 
                                          $$->code = string(buffer); 
                                        }

                        ;


Fact           : IDENT
//Marina Summer2001
//The include files for the properties are added to the list.
//Fact was modified to emit the appropriate CCond and NonTypeArgs objects.

{   

                                        
                                          $$ = new PAStmt;
                                          int strlength = strlen("new CCond(") + strlen($1) + 20  + strlen(", NULL)") + 1;
                                          buffer = new char[strlength]; 
                                          sprintf(buffer, "new CCond(%s%s, NULL)", $1, "Property::instance()"); 
                                          $$->code = string(buffer);   
                                          
                                          int pl_strlength = strlen($1) + 1;
                                          pl_buffer = new char[pl_strlength]; 
                                          sprintf(pl_buffer, "%s", $1); 
                                        }

| IDENT '(' VarList ')'                

{ 
                                        
                                          $$ = new PAStmt;
                                          int strlength = strlen("new CCond(") + strlen($1) + 
                                            20 + strlen(", ") + strlen( "new NonTypeArgs(1, ") +  strlen($3->code.chars()) + strlen(", NULL) )") + 1;
                                          buffer = new char[strlength]; 
                                          sprintf(buffer, "new CCond(%s%s, new NonTypeArgs(1, %s, NULL) )", $1,"Property::instance()", $3->code.chars()); 
                                          $$->code = string(buffer);   
                                   
                                   
                                        }

                ;

VarList         : VarList ',' kType 

                    {
                                          $$ = new PAStmt;
                                          theRRSet.insert(theRRSet.begin(), string("TWrap"));
                                          
                                          strlength = strlen($1->code.chars()) + strlen(", ") + 
                                                strlen("new TWrap(") + strlen($3->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength]; 
                                          sprintf(buffer, "%s, new TWrap(%s)", $1->code.chars(), $3->code.chars()); 
                                          $$->code = string(buffer);   
                                   
                                        }

                |  kType

                    {
                                          $$ = new PAStmt;
                                          strlength = strlen($1->code.chars()) + strlen("new TWrap(") + strlen(")") + 1;
                                          buffer = new char[strlength]; 
                                          sprintf(buffer, "new TWrap(%s)", $1->code.chars()); 
                                          $$->code = string(buffer);
                                          
                                         
                                          
                                        }

                |  VarList ',' FIDENT

                    {
                                          theDVList.push_back(string($3));
                                          PAPair thePair;
                                          thePair.second = FUNC;
                                          theRRSet.insert(theRRSet.begin(), string("FVar"));
                                          theIdentTable.insert(PAIdentTable::value_type(string($3), thePair));
                                          
                                          $$ = new PAStmt;
                                          strlength = strlen($1->code.chars()) + strlen(", ") + strlen("new FVar(\"") + strlen($3) + strlen("\")") + 1;
                                          buffer = new char[strlength]; 
                                          sprintf(buffer, "%s, new FVar(\"%s\")", $1->code.chars(), $3); 
                                          $$->code = string(buffer);   
                                          
                                         
                                   
                                        }

                |  FIDENT

                    {
                                          theDVList.push_back(string($1));
                                          PAPair thePair;
                                          thePair.second = FUNC;
                                          theRRSet.insert(theRRSet.begin(), string("FVar"));
                                          theIdentTable.insert(PAIdentTable::value_type(string($1), thePair));
                                          
                                          $$ = new PAStmt;
                                          strlength = strlen("new FVar(\"") + strlen($1) + strlen("\")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new FVar(\"%s\")", $1);
                                          $$->code = string(buffer);
                                          
                                        
                                          
                                        }

                |  VarList ',' BIDENT

                    {
                                          theDVList.push_back(string($3));
                                          PAPair thePair;
                                          thePair.second = BOOL;
                                          theRRSet.insert(theRRSet.begin(), string("BVar"));
                                          theIdentTable.insert(PAIdentTable::value_type(string($3), thePair));
                                          
                                          $$ = new PAStmt;
                                          strlength = strlen($1->code.chars()) + strlen(", ") + strlen("new BVar(\"") + strlen($3) + strlen("\")") + 1;
                                          buffer = new char[strlength]; 
                                          sprintf(buffer, "%s, new BVar(\"%s\")", $1->code.chars(), $3); 
                                          $$->code = string(buffer);  
                                          
                                         
                                        }

                |  BIDENT

                    {
                                          theDVList.push_back(string($1));
                                          PAPair thePair;
                                          thePair.second = BOOL;
                                          theRRSet.insert(theRRSet.begin(), string("BVar"));
                                          theIdentTable.insert(PAIdentTable::value_type(string($1), thePair));
                                          
                                          $$ = new PAStmt;
                                          strlength = strlen("new BVar(\"") + strlen($1) + strlen("\")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new BVar(\"%s\")", $1);
                                          $$->code = string(buffer);
                                          
                                
                                        }

                |  VarList ',' OIDENT

                    {
                                          theDVList.push_back(string($3));
                                          theRRSet.insert(theRRSet.begin(), string("OVar"));
                                          PAPair thePair;
                                          thePair.second = OBJ;
                                          theIdentTable.insert(PAIdentTable::value_type(string($3), thePair));
                                          
                                          $$ = new PAStmt;
                                          strlength = strlen($1->code.chars()) + strlen(", ") + strlen("new OVar(\"") + strlen($3) + strlen("\")") + 1;
                                          buffer = new char[strlength]; 
                                          sprintf(buffer, "%s, new OVar(\"%s\")", $1->code.chars(), $3); 
                                          $$->code = string(buffer);  
                                          
                                         

                                        }

                |  OIDENT

                    {
                                          theDVList.push_back(string($1));
                                          theRRSet.insert(theRRSet.begin(), string("OVar"));
                                          PAPair thePair;
                                          thePair.second = OBJ;
                                          theIdentTable.insert(PAIdentTable::value_type(string($1), thePair));
                                          
                                          $$ = new PAStmt;
                                          strlength = strlen("new OVar(\"") + strlen($1) + strlen("\")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new OVar(\"%s\")", $1);
                                          $$->code = string(buffer);
                                         
                                        }

                |  VarList ',' PIDENT

                    {
                                          theDVList.push_back(string($3));
                                          PAPair thePair;
                                          thePair.second = PRED;
                                          theRRSet.insert(theRRSet.begin(), string("PVar"));
                                          theIdentTable.insert(PAIdentTable::value_type(string($3), thePair));
                                          
                                          $$ = new PAStmt;
                                          strlength = strlen($1->code.chars()) + strlen(", ") + strlen("new PVar(\"") + strlen($3) + strlen("\")") + 1;
                                          buffer = new char[strlength]; 
                                          sprintf(buffer, "%s, new PVar(\"%s\")", $1->code.chars(), $3); 
                                          $$->code = string(buffer); 
                                          
                                         
                                   
                                        }

                |  PIDENT

                    {
                                          theDVList.push_back(string($1));
                                          PAPair thePair;
                                          thePair.second = PRED;
                                          theRRSet.insert(theRRSet.begin(), string("PVar"));
                                          theIdentTable.insert(PAIdentTable::value_type(string($1), thePair));
                                          
                                          $$ = new PAStmt;
                                          strlength = strlen("new PVar(\"") + strlen($1) + strlen("\")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new PVar(\"%s\")", $1);
                                          $$->code = string(buffer);
                                          
                                        
                                        }

               ;

/********************************************************************************
 ********************************************************************************
 
   Rules
   
   What Constitutes a KOLA Rule?
   
********************************************************************************
********************************************************************************/

/********************************************************************************

RuleP, RuleF, RuleO, RuleB

   A rule is of the form E1 '-->' E2, where E1 and E2 are expressions
   denoting KOLA functions, predicates, bools or objects.
   That is, a rule expression is any KOLA expression, potentially with variables.
   
   
********************************************************************************/

RuleP            :  RuleHead RulePBody { $$ = $2; }
                 ;

RuleF            :  RuleHead RuleFBody { $$ = $2; }
                 ;

RuleO            :  RuleHead RuleOBody { $$ = $2; }
                 ;

RuleB            :  RuleHead RuleBBody { $$ = $2; }
                 ;

RuleHead         :  { theStack.push(theIdentTable); }
                 ;

RulePBody        :  Pred GOESTO Pred

{
                      //DJA SUMMER 2001
                      //I had to change what the Rule Body returned in order to store the name of the rule in the CRule
                      //originally, this code looked like:
                      //new CRule(new CPattern(....), new CPattern(....))
                      //but I wanted to put the name of the Rule in the constructor of the Rule like:
                      //new CRule("dist1", new CPattern(...), new CPattern(....))
                      //but here we don't know the name of the rule, so instead this returns the middle of the rule code:
                      //new CPattern(...), new CPattern(....)
                      //and let the USES section fill in the beginning while it has access to the name IDENT
                      //same deal for RuleFBody, RuleOBody, and RuleBBody.
                                          $$ = new PARule;
                                          strlength = strlen("new CPattern(") + strlen($1->code.chars())
                                                + strlen("), new CPattern(") + strlen($3->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new CPattern(%s), new CPattern(%s)",
                                                          $1->code.chars(), $3->code.chars());
                                          $$->code = string(buffer);
                                          $$->precond = false;
                                          $$->type = determine_rule_type($1->decl, $3->decl);
                                          theIdentTable = theStack.top();
                                          theStack.pop();
                                          
                                        
                                     }

                |  PreCond Pred GOESTO Pred

                    {
                      $$ = new PARule;
                      strlength =  strlen($1->code.chars()) + 
                                                strlen(", new CPattern(") + strlen($2->code.chars())
                        + strlen("), new CPattern(") + strlen($4->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "%s, new CPattern(%s), new CPattern(%s)",
                              $1->code.chars(), $2->code.chars(), $4->code.chars());
                      $$->code = string(buffer);
                      $$->type = determine_rule_type($2->decl, $4->decl);
                      $$->precond = true;
                      theIdentTable = theStack.top();
                      theStack.pop();
                                          
                                         

                                        }

                ;

RuleFBody       :  Func GOESTO Func  

                    {
                      $$ = new PARule;
                      strlength = strlen("new CPattern(") + strlen($1->code.chars())
                        + strlen("), new CPattern(") + strlen($3->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new CPattern(%s), new CPattern(%s)",
                              $1->code.chars(), $3->code.chars());
                      $$->code = string(buffer);
                      $$->precond = false;
                      $$->type = determine_rule_type($1->decl, $3->decl);
                      theIdentTable = theStack.top();
                      theStack.pop();
                                
                                          
                                        }

                |  PreCond Func GOESTO Func  

                    {
                      $$ = new PARule;
                      strlength = strlen($1->code.chars()) + 
                                                strlen(", new CPattern(") + strlen($2->code.chars())
                        + strlen("), new CPattern(") + strlen($4->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "%s, new CPattern(%s), new CPattern(%s)",
                              $1->code.chars(), $2->code.chars(), $4->code.chars());
                      $$->code = string(buffer);
                      $$->type = determine_rule_type($2->decl, $4->decl);
                      $$->precond = true;
                      theIdentTable = theStack.top();
                      theStack.pop();

                                
                                        }

                ;

RuleOBody       :  Obj GOESTO Obj  

{
                      $$ = new PARule;
                      strlength = strlen("new CPattern(") + strlen($1->code.chars())
                        + strlen("), new CPattern(") + strlen($3->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new CPattern(%s), new CPattern(%s)",
                              $1->code.chars(), $3->code.chars());
                      $$->code = string(buffer);
                      $$->precond = false;
                      $$->type = determine_rule_type($1->decl, $3->decl);
                      theIdentTable = theStack.top();
                      theStack.pop();
                                        
                                          
                    }

                |  PreCond Obj GOESTO Obj  

{
                      $$ = new PARule;
                      strlength = strlen($1->code.chars()) + 
                        strlen(", new CPattern(") + strlen($2->code.chars())
                        + strlen("), new CPattern(") + strlen($4->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "%s, new CPattern(%s), new CPattern(%s)",
                              $1->code.chars(), $2->code.chars(), $4->code.chars());
                      $$->code = string(buffer);
                      $$->precond = true;
                      $$->type = determine_rule_type($2->decl, $4->decl);
                      theIdentTable = theStack.top();
                      theStack.pop();
                                          
                                
                    }
                    
                ;

RuleBBody       :  Bool GOESTO Bool 

                    {
                      $$ = new PARule;
                      strlength = strlen("new CPattern(") + strlen($1->code.chars())
                        + strlen("), new CPattern(") + strlen($3->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new CPattern(%s), new CPattern(%s)",
                              $1->code.chars(), $3->code.chars());
                      $$->code = string(buffer);
                      $$->precond = false;
                      $$->type = determine_rule_type($1->decl, $3->decl);
                      theIdentTable = theStack.top();
                      theStack.pop();
                                          
                                

                                        }

                |  PreCond Bool GOESTO Bool  

                    {
                                          $$ = new PARule;
                      strlength = strlen($1->code.chars()) + 
                                                strlen(", new CPattern(") + strlen($2->code.chars())
                        + strlen("), new CPattern(") + strlen($4->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "%s, new CPattern(%s), new CPattern(%s)",
                              $1->code.chars(), $2->code.chars(), $4->code.chars());
                      $$->code = string(buffer);
                      $$->precond = true;
                      $$->type = determine_rule_type($2->decl, $4->decl);
                      theIdentTable = theStack.top();
                      theStack.pop();
                                          
                                         
                    }

                 ;


/********************************************************************************
  Pred
   
  Predicate Rule Expressions.
  Note that predicate variables (PIDENT) are assumed to be of the form

              p, p', p'', ...
       p1, p2, p3, ...
       q, q', q'', ...
       q1, q2, q3, ...
       r, r', r'', ...
       r1, r2, r3, ...
           
********************************************************************************/

Pred            :  PrimP { $$ = $1;}

                |  FormP { $$ = $1;}

                |  PIDENT 

{
                                          theDVList.push_back(string($1));
                                          PAPair thePair;
                                          thePair.second = PRED;
                                          theRRSet.insert(theRRSet.begin(), string("PVar"));
                                          theIdentTable.insert(PAIdentTable::value_type(string($1), thePair));
                                          
                                          $$ = new PAPattern;
                                          strlength = strlen("new PVar(\"") + strlen($1) + strlen("\")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new PVar(\"%s\")", $1);
                                          $$->code = string(buffer);
                                          $$->decl.insert(string($1));
                                          
                                          
                                        }  

                |  PPREFIX '(' IDENT ',' kType ')'

                    {
                                          theDVList.push_back(string($3));
                                          PAPair thePair;
                                          thePair.second = PRED;
                                          theRRSet.insert(theRRSet.begin(), string("PUser"));
                                          theIdentTable.insert(PAIdentTable::value_type(string($3), thePair));
                                          
                                          $$ = new PAPattern;
                                          strlength = strlen("new PUser(\"") + strlen($3) + strlen("\",new TPred()")  + strlen($5->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new PUser(\"%s\",new TPred(%s))", $3, $5->code.chars());
                                          $$->code = string(buffer);
                                          $$->decl.insert(string($3));
                                          
                                         
                                          
                                        }  

                |  PDC    

                    {
                                          /* theRRSet.insert(theRRSet.begin(), string("PDCRR")); */
                                          theRRSet.insert(theRRSet.begin(), string("PVar"));
                                          
                                          $$ = new PAPattern;
                                          char count[10];
                                          sprintf(count, "%d", DCcount++);
                                          strlength = strlen("new PVar(\"_P") + strlen(count) + strlen("\")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new PVar(\"_P%s\")", count);
                                          $$->code = string(buffer);
                                          
                                
                                          
                                        }

                ;

PrimP           :  PEQUAL      

                    {
                                          theRRSet.insert(theRRSet.begin(), string("PEqual"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new PEqual") + 1;
                                          buffer = new char[strlength];
                                          strcpy(buffer, "new PEqual");
                                          $$->code = string(buffer);
                                          
                                
                                          
                    }

                |  NE

                    {
                                          theRRSet.insert(theRRSet.begin(), string("PNotEqual"));
                      $$ = new PAPattern;
                      strlength = strlen("new PNotEqual") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new PNotEqual");
                      $$->code = string(buffer);
                                          
                                
                                          
                    }

                |  LESS       

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("PLess"));
                      $$ = new PAPattern;
                      strlength = strlen("new PLess") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new PLess");
                      $$->code = string(buffer);
                                
                                          
                    }

                |  GREATER

                    {
                                          theRRSet.insert(theRRSet.begin(), string("PGreater"));
                      $$ = new PAPattern;
                      strlength = strlen("new PGreater") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new PGreater");
                      $$->code = string(buffer);
                                          
                                
                                          
                    }                    

                |  LE     

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("PLessEqual"));
                      $$ = new PAPattern;
                      strlength = strlen("new PLessEqual") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new PLessEqual");
                      $$->code = string(buffer);
                                
                    }

                |  GE

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("PGreaterEqual"));
                      $$ = new PAPattern;
                      strlength = strlen("new PGreaterEqual") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new PGreaterEqual");
                      $$->code = string(buffer);
                                          
                                
                                          
                    }
                    
                ;

FormP           :  Pred OPLUS Func

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("PCombine"));
                      $$ = new PAPattern;
                      strlength = strlen("new PCombine(") + strlen($1->code.chars())
                        + strlen(", ") + strlen($3->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new PCombine(%s, %s)", $1->code.chars(), $3->code.chars());
                      $$->code = string(buffer);
                      set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                
                    }

                |  PLEX '(' Pred ',' Pred ')'

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("PLex"));
                      $$ = new PAPattern;
                      strlength = strlen("new PLex(") + strlen($3->code.chars())
                        + strlen(", ") + strlen($5->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new PLex(%s, %s)", $3->code.chars(), $5->code.chars());
                      $$->code = string(buffer);
                      set_union($3->decl.begin(), $3->decl.end(), $5->decl.begin(), $5->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                        
                    }

                |  Pred '&' Pred

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("PConjunct"));
                      $$ = new PAPattern;
                      strlength = strlen("new PConjunct(") + strlen($1->code.chars())
                        + strlen(", ") + strlen($3->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new PConjunct(%s, %s)", $1->code.chars(), $3->code.chars());
                      $$->code = string(buffer);
                      set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                
                                          
                    }

                |  Pred '|' Pred

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("PDisjunct"));
                      $$ = new PAPattern;
                      strlength = strlen("new PDisjunct(") + strlen($1->code.chars())
                        + strlen(", ") + strlen($3->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new PDisjunct(%s, %s)", $1->code.chars(), $3->code.chars());
                      $$->code = string(buffer);
                      set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                
                    }

                |  NOT '(' Pred ')'   

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("PNegate"));
                      $$ = new PAPattern;
                      strlength = strlen("new PNegate(") + strlen($3->code.chars())
                        + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new PNegate(%s)", $3->code.chars());
                      $$->code = string(buffer);
                      $$->decl = $3->decl;
                
                                          
                    }

                |  CONST '(' Bool ')'     

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("PConst"));
                      $$ = new PAPattern;
                      strlength = strlen("new PConst(") + strlen($3->code.chars())
                        + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new PConst(%s)", $3->code.chars());
                      $$->code = string(buffer);
                      $$->decl = $3->decl;
                
                                          
                    }

                |  CURRY '(' Pred ',' Obj ')' 

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("PCElt"));
                      $$ = new PAPattern;
                      strlength = strlen("new PCElt(") + strlen($3->code.chars())
                        + strlen(", ") + strlen($5->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new PCElt(%s, %s)", $3->code.chars(), $5->code.chars());
                      $$->code = string(buffer);
                      set_union($3->decl.begin(), $3->decl.end(), $5->decl.begin(), $5->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                    
                                          
                    }

                |  Pred FINV   

                    { 
                      theRRSet.insert(theRRSet.begin(), string("PInv"));
                      $$ = new PAPattern;
                      strlength = strlen("new PInv(") + strlen($1->code.chars())
                        + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new PInv(%s)", $1->code.chars());
                      $$->code = string(buffer);
                      $$->decl = $1->decl;
                                          
                    
                                          
                                        }

                |  Pred TIMES Pred    

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("PTimes"));
                      $$ = new PAPattern;
                      strlength = strlen("new PTimes(") + strlen($1->code.chars())
                        + strlen(", ") + strlen($3->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new PTimes(%s, %s)", $1->code.chars(), $3->code.chars());
                      $$->code = string(buffer);
                      set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                    
                                          
                    }

                |  Pred XTIMES Pred    

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("PTimes"));
                      $$ = new PAPattern;
                      strlength = strlen("new PTimes(") + strlen($1->code.chars())
                        + strlen(", ") + strlen($3->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new PTimes(%s, %s)", $1->code.chars(), $3->code.chars());
                      $$->code = string(buffer);
                      set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                     
                                          
                    }

                |  EXISTS '(' Pred ')'    

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("PExists"));
                      $$ = new PAPattern;
                      strlength = strlen("new PExists(") + strlen($3->code.chars())
                        + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new PExists(%s)", $3->code.chars());
                      $$->code = string(buffer);
                      $$->decl = $3->decl;
                                          
                     
                                          
                    }

                |  FORALL '(' Pred ')'    

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("PForall"));
                      $$ = new PAPattern;
                      strlength = strlen("new PForall(") + strlen($3->code.chars())
                        + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new PForall(%s)", $3->code.chars());
                      $$->code = string(buffer);
                      $$->decl = $3->decl;
                                          
                    
                                          
                    }


                |  EX '(' Pred ')'    

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("PCEX"));
                      $$ = new PAPattern;
                      strlength = strlen("new PCEX(") + strlen($3->code.chars())
                        + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new PCEX(%s)", $3->code.chars());
                      $$->code = string(buffer);
                      $$->decl = $3->decl;
                
                                          
                    }

                |  FA '(' Pred ')'        
   
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("PCFA"));
                      $$ = new PAPattern;
                      strlength = strlen("new PCFA(") + strlen($3->code.chars())
                        + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new PCFA(%s)", $3->code.chars());
                      $$->code = string(buffer);
                      $$->decl = $3->decl;
                                          
                    
                                          
                    }

                |  '(' Pred ')'   

                    { $$ = $2; }

                ;

/********************************************************************************
 Func
   
 Function Rule Expressions.
 Note that function variables (FIDENT) are assumed to be of the form

       f, f', f'', ...
       f1, f2, f3, ...
       g, g', g'', ...
       g1, g2, g3, ...
       h, h', h'', ...
       h1, h2, h3, ...
           
********************************************************************************/

Func            :  PrimF  { $$ = $1; }

                |  FormF  

                    { $$ = $1; }

                |  FIDENT 

                    {
                                          theDVList.push_back(string($1));
                                          PAPair thePair;
                                          thePair.second = FUNC;
                                          theRRSet.insert(theRRSet.begin(), string("FVar"));
                                          theIdentTable.insert(PAIdentTable::value_type(string($1), thePair));
                                          $$ = new PAPattern;
                                          strlength = strlen("new FVar(\"") + strlen($1) + strlen("\")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new FVar(\"%s\")", $1);
                                          $$->code = string(buffer);
                                          $$->decl.insert(string($1));
                                          
                                
                                        }

                          |  FPREFIX '(' IDENT ',' kType ',' kType ')' 

                    {
                                          theDVList.push_back(string($3));
                                          PAPair thePair;
                                          thePair.second = FUNC;
                                          theRRSet.insert(theRRSet.begin(), string("FUser"));

                                          theIdentTable.insert(PAIdentTable::value_type(string($3), thePair));
                                          $$ = new PAPattern;
                                          strlength = strlen("new FUser(\"") + strlen($3) + strlen("\",new TFunc(,)") 
                                + strlen($5->code.chars()) + strlen($7->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new FUser(\"%s\",new TFunc(%s,%s))", $3,$5->code.chars(),$7->code.chars());
                                          $$->code = string(buffer);
                                          $$->decl.insert(string($3));
                                
                                        }

                |  FDC    

                    { 
                                          /* theRRSet.insert(theRRSet.begin(), string("FDCRR")); */
                                          theRRSet.insert(theRRSet.begin(), string("FVar"));
                                          $$ = new PAPattern;
                                          char count[10];
                                          sprintf(count, "%d", DCcount++);
                                          
                                          strlength = strlen("new FVar(\"_F") + strlen(count) + strlen("\")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new FVar(\"_F%s\")", count);
                                          $$->code = string(buffer);
                                
                                          
                                        }

                ;

PrimF           :  ID 
                    
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FID"));
                      $$ = new PAPattern;
                      strlength = strlen("new FID") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new FID");
                      $$->code = string(buffer);
                ;
                                          
                    }

                |  TID

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FTID"));
                      $$ = new PAPattern;
                      strlength = strlen("new FTID") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new FTID");
                      $$->code = string(buffer);
                                          
                    
                                          
                    }

                |  ABS

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FAbs"));
                      $$ = new PAPattern;
                      strlength = strlen("new FAbs") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new FAbs");
                      $$->code = string(buffer);
                                          
                  
                    }

                |  FAVG

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FAvg"));
                      $$ = new PAPattern;
                      strlength = strlen("new FAvg") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new FAvg");
                      $$->code = string(buffer);
                
                                          
                    }

                |  MOD

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FMod"));
                      $$ = new PAPattern;
                      strlength = strlen("new FMod") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new FMod");
                      $$->code = string(buffer);
                                          
                    
                    }

                |  INV

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FInv"));
                      $$ = new PAPattern;
                      strlength = strlen("new FInv") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new FInv");
                      $$->code = string(buffer);
                
                                          
                    }

                |  FSUM

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FSum"));
                      $$ = new PAPattern;
                      strlength = strlen("new FSum") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new FSum");
                      $$->code = string(buffer);
                ;
                                          
                    }


                |  FCOUNT

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FCount"));
                      $$ = new PAPattern;
                      strlength = strlen("new FCount") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new FCount");
                      $$->code = string(buffer);
                                          
                    
                    }

                |  FMAX

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FMax"));
                      $$ = new PAPattern;
                      strlength = strlen("new FMax") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new FMax");
                      $$->code = string(buffer);
                
                                          
                    }


                |  FMIN

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FMin"));
                      $$ = new PAPattern;
                      strlength = strlen("new FMin") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new FMin");
                      $$->code = string(buffer);
                
                                          
                    }

                |  FADD

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FAdd"));
                      $$ = new PAPattern;
                      strlength = strlen("new FAdd") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new FAdd");
                      $$->code = string(buffer);
                
                                          
                    }

                |  FSUB

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FMinus"));
                      $$ = new PAPattern;
                      strlength = strlen("new FMinus") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new FMinus");
                      $$->code = string(buffer);
                

                    }

                |  FMUL

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FMult"));
                      $$ = new PAPattern;
                      strlength = strlen("new FMult") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new FMult");
                      $$->code = string(buffer);

                    
                                          
                    }

                |  FDIV

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FDiv"));
                      $$ = new PAPattern;
                      strlength = strlen("new FDiv") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new FDiv");
                      $$->code = string(buffer);
                                          
                     

                    }

                |  SINGLETON

                    {
                                          theRRSet.insert(theRRSet.begin(), string("FSingleton"));
                                          $$ = new PAPattern;
                      strlength = strlen("new FSingleton") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new FSingleton");
                      $$->code = string(buffer);

                                          
                    }

                | SET    

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FSet"));
                      $$ = new PAPattern;
                      strlength = strlen("new FSet") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new FSet");
                      $$->code = string(buffer);
                                          
                   
                    }

                |  ONE    

                    {
                                          theRRSet.insert(theRRSet.begin(), string("F1"));
                      $$ = new PAPattern;
                      strlength = strlen("new F1") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new F1");
                      $$->code = string(buffer);

                                          
                    }

                |  TWO    

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("F2"));
                      $$ = new PAPattern;
                      strlength = strlen("new F2") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new F2");
                      $$->code = string(buffer);
                

                    }

                |  SHIFTL 

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FShiftL"));
                      $$ = new PAPattern;
                      strlength = strlen("new FShiftL") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new FShiftL");
                      $$->code = string(buffer);
                

                    }

                |  SHIFTR 

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FShiftR"));
                      $$ = new PAPattern;
                      strlength = strlen("new FShiftR") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new FShiftR");
                      $$->code = string(buffer);

                    }

                |  CHOOSE 

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FChoose"));
                      $$ = new PAPattern;
                      strlength = strlen("new FChoose") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new FChoose");
                      $$->code = string(buffer);
                

                    }

                |  FLATTEN 

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FFlatten"));
                      $$ = new PAPattern;
                      strlength = strlen("new FFlatten") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new FFlatten");
                      $$->code = string(buffer);

                                          
                    }

                |  INS   

                    {
                      theRRSet.insert(theRRSet.begin(), string("FIns"));
                      $$ = new PAPattern;
                      strlength = strlen("new FIns") + 1;
                      buffer = new char[strlength];
                      strcpy(buffer, "new FIns");
                      $$->code = string(buffer);

                    }

                ;

FormF           :  CONST '(' Obj ')' 

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FConst"));
                      $$ = new PAPattern;
                      strlength = strlen("new FConst(") + strlen($3->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new FConst(%s)", $3->code.chars());
                      $$->code = string(buffer);
                      $$->decl = $3->decl;

                    }
                                        
                |  CURRY '(' Func ',' Obj ')' 

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FCElt"));
                      $$ = new PAPattern;
                      strlength = strlen("new FCElt(") + strlen($3->code.chars()) 
                        + strlen(", ") + strlen($5->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new FCElt(%s, %s)", $3->code.chars(), $5->code.chars());
                      $$->code = string(buffer);
                      set_union($3->decl.begin(), $3->decl.end(), $5->decl.begin(), $5->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));

                    
                    }

                |  Func TIMES Func 
                                
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FTimes"));
                      $$ = new PAPattern;
                      strlength = strlen("new FTimes(") + strlen($1->code.chars()) 
                        + strlen(", ") + strlen($3->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new FTimes(%s, %s)", $1->code.chars(), $3->code.chars());
                      $$->code = string(buffer);
                      set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                
                                          
                    }
                |  Func XTIMES Func 

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FTimes"));
                      $$ = new PAPattern;
                      strlength = strlen("new FTimes(") + strlen($1->code.chars()) 
                        + strlen(", ") + strlen($3->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new FTimes(%s, %s)", $1->code.chars(), $3->code.chars());
                      $$->code = string(buffer);
                      set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                   
                    }

                |  Func CIRC Func  

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FCompose"));
                      $$ = new PAPattern;
                      strlength = strlen("new FCompose(") + strlen($1->code.chars()) 
                        + strlen(", ") + strlen($3->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new FCompose(%s, %s)", $1->code.chars(), $3->code.chars());
                      $$->code = string(buffer);
                      set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));

                    
                    }

                |  Func PLUS Func  

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FPlus"));
                      $$ = new PAPattern;
                      strlength = strlen("new FPlus(") + strlen($1->code.chars()) 
                        + strlen(", ") + strlen($3->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new FPlus(%s, %s)", $1->code.chars(), $3->code.chars());
                      $$->code = string(buffer);
                      set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                     
                    }

                |  LANGLE Func ',' Func RANGLE

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FPlus"));
                      $$ = new PAPattern;
                      strlength = strlen("new FPlus(") + strlen($2->code.chars()) 
                        + strlen(", ") + strlen($4->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new FPlus(%s, %s)", $2->code.chars(), $4->code.chars());
                      $$->code = string(buffer);
                      set_union($2->decl.begin(), $2->decl.end(), $4->decl.begin(), $4->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));

                     
                    }

                |  CON '(' Pred ',' Func ',' Func ')' 

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FCon"));
                      $$ = new PAPattern;
                      strlength = strlen("new FCon(") + strlen($3->code.chars()) 
                        + strlen(", ") + strlen($5->code.chars()) + strlen(", ") + strlen($7->code.chars())
                        + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new FCon(%s, %s, %s)", $3->code.chars(), 
                              $5->code.chars(), $7->code.chars());
                      $$->code = string(buffer);
                      PAIdentSet temp;
                      set_union($3->decl.begin(), $3->decl.end(), $5->decl.begin(), $5->decl.end(),
                                insert_iterator<PAIdentSet> (temp, temp.begin()));
                      set_union(temp.begin(), temp.end(), $7->decl.begin(), $7->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));

                                          
                    
                    }

                |  UNI '(' Pred ')'  

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FUni"));
                      $$ = new PAPattern;
                      strlength = strlen("new FUni(") + strlen($3->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new FUni(%s)", $3->code.chars());
                      $$->code = string(buffer);
                      $$->decl = $3->decl;

                    }

                |  INT '(' Pred ')'  

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FInt"));
                      $$ = new PAPattern;
                      strlength = strlen("new FInt(") + strlen($3->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new FInt(%s)", $3->code.chars());
                      $$->code = string(buffer);
                      $$->decl = $3->decl;

                    }

                |  DIF '(' Pred ')'  

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FDif"));
                      $$ = new PAPattern;
                      strlength = strlen("new FDif(") + strlen($3->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new FDif(%s)", $3->code.chars());
                      $$->code = string(buffer);
                      $$->decl = $3->decl;

                               
                    }

                |  SORT '(' Pred ')'

                    {
                                          theRRSet.insert(theRRSet.begin(), string("FSort"));
                      $$ = new PAPattern;
                      strlength = strlen("new FSort(") + strlen($3->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new FSort(%s)", $3->code.chars());
                      $$->code = string(buffer);
                      $$->decl = $3->decl;
          
                    }

                |  PFOLD '(' Func ',' Func ')' 

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FPFold"));
                      $$ = new PAPattern;
                      strlength = strlen("new FPFold(") + strlen($3->code.chars())
                        + strlen(", ") + strlen($5->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new FPFold(%s, %s)", $3->code.chars(), $5->code.chars());
                      $$->code = string(buffer);
                      set_union($3->decl.begin(), $3->decl.end(), $5->decl.begin(), $5->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));

                    
                    }

                |  NJOIN '(' Pred ',' Func ',' Func ')'

                    {
                                          theRRSet.insert(theRRSet.begin(), string("FNJoin"));
                                          $$ = new PAPattern;
                      strlength = strlen("new FNJoin(") + strlen($3->code.chars()) 
                                                + strlen(", ") + strlen($5->code.chars()) + strlen(", ") + strlen($7->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new FNJoin(%s, %s, %s)", $3->code.chars(), $5->code.chars(), $7->code.chars());
                      $$->code = string(buffer);
                      PAIdentSet temp;
                      set_union($3->decl.begin(), $3->decl.end(), $5->decl.begin(), $5->decl.end(),
                                insert_iterator<PAIdentSet> (temp, temp.begin()));
                      set_union(temp.begin(), temp.end(), $7->decl.begin(), $7->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));                                          

                
                    }

                |  FOLD '(' Obj ',' Func ',' Func ')'
   
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FFold"));
                      $$ = new PAPattern;
                      strlength = strlen("new FFold(") + strlen($3->code.chars()) 
                        + strlen(", ") + strlen($5->code.chars()) + strlen(", ") + strlen($7->code.chars())
                        + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new FFold(%s, %s, %s)", $3->code.chars(), $5->code.chars(), 
                              $7->code.chars());
                      $$->code = string(buffer);
                      PAIdentSet temp;
                      set_union($3->decl.begin(), $3->decl.end(), $5->decl.begin(), $5->decl.end(),
                                insert_iterator<PAIdentSet> (temp, temp.begin()));
                      set_union(temp.begin(), temp.end(), $7->decl.begin(), $7->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                     
                    }

                |  ITERATE '(' Pred ',' Func ')'

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FIterate"));
                      $$ = new PAPattern;
                      strlength = strlen("new FIterate(") + strlen($3->code.chars()) 
                        + strlen(", ") + strlen($5->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new FIterate(%s, %s)", $3->code.chars(), $5->code.chars());
                      $$->code = string(buffer);
                      set_union($3->decl.begin(), $3->decl.end(), $5->decl.begin(), $5->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));

                    
                    }

                |  ITER '(' Pred ',' Func ')'   

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FIter"));
                      $$ = new PAPattern;
                      strlength = strlen("new FIter(") + strlen($3->code.chars()) 
                        + strlen(", ") + strlen($5->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new FIter(%s, %s)", $3->code.chars(), $5->code.chars());
                      $$->code = string(buffer);
                      set_union($3->decl.begin(), $3->decl.end(), $5->decl.begin(), $5->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                   
                    }

                |  PCON '(' Pred ',' Func ')'   

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FPCon"));
                      $$ = new PAPattern;
                      strlength = strlen("new FPCon(") + strlen($3->code.chars()) 
                        + strlen(", ") + strlen($5->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new FPCon(%s, %s)", $3->code.chars(), $5->code.chars());
                      $$->code = string(buffer);
                      set_union($3->decl.begin(), $3->decl.end(), $5->decl.begin(), $5->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));

                  
                    }

                |  JOIN '(' Pred ',' Func ')'   

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FJoin"));
                      $$ = new PAPattern;
                      strlength = strlen("new FJoin(") + strlen($3->code.chars()) 
                        + strlen(", ") + strlen($5->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new FJoin(%s, %s)", $3->code.chars(), $5->code.chars());
                      $$->code = string(buffer);
                      set_union($3->decl.begin(), $3->decl.end(), $5->decl.begin(), $5->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                   
                    }

                |  RSJOIN '(' Pred ',' Func ')'

                    {
                                          theRRSet.insert(theRRSet.begin(), string("FRSJoin"));
                      $$ = new PAPattern;
                      strlength = strlen("new FRSJoin(") + strlen($3->code.chars())
                        + strlen(", ") + strlen($5->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new FRSJoin(%s, %s)", $3->code.chars(), $5->code.chars());
                      $$->code = string(buffer);
                      set_union($3->decl.begin(), $3->decl.end(), $5->decl.begin(), $5->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));

                     

                                          
                    }

                |  LSJOIN '(' Pred ',' Func ')'

                    {
                                          theRRSet.insert(theRRSet.begin(), string("FLSJoin"));
                      $$ = new PAPattern;
                      strlength = strlen("new FLSJoin(") + strlen($3->code.chars())
                        + strlen(", ") + strlen($5->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new FLSJoin(%s, %s)", $3->code.chars(), $5->code.chars());
                      $$->code = string(buffer);
                      set_union($3->decl.begin(), $3->decl.end(), $5->decl.begin(), $5->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));

                
                    }

                |  UNNEST '(' Func ',' Func ')' 

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("FUnnest"));
                      $$ = new PAPattern;
                      strlength = strlen("new FUnnest(") + strlen($3->code.chars()) 
                        + strlen(", ") + strlen($5->code.chars()) + strlen(")") + 1;
                      buffer = new char[strlength];
                      sprintf(buffer, "new FUnnest(%s, %s)", $3->code.chars(), $5->code.chars());
                      $$->code = string(buffer);
                      set_union($3->decl.begin(), $3->decl.end(), $5->decl.begin(), $5->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));

                     
                    }

                |  '(' Func ')'   { $$ = $2;}

                ;


/********************************************************************************
 Obj
 
 Object Rule Expressions.
 Note that object variables (OIDENT) are assumed to be of the form

           x, x', x'', ...
       x1, x2, x3, ...
       y, y', y'', ...
       y1, y2, y3, ...
       z, z', z'', ...
       z1, z2, z3, ...
       A, A', A'', ...
       A1, A2, A3, ...
       B, B', B'', ...
       B1, B2, B3, ...
       C, C', C'', ...
       C1, C2, C3, ...
           
********************************************************************************/

Obj             :  PrimO  { $$ = $1;                           }

                |  FormO  

                    { $$ = $1;                           }

                |  OIDENT 

                    { 
                                          theDVList.push_back(string($1));
                                          theRRSet.insert(theRRSet.begin(), string("OVar"));
                                          PAPair thePair;
                                          thePair.second = OBJ;
                                          theIdentTable.insert(PAIdentTable::value_type(string($1), thePair));
                                          $$ = new PAPattern;
                                          strlength = strlen("new OVar(\"") + strlen($1) + strlen("\")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new OVar(\"%s\")", $1);
                                          $$->code = string(buffer);
                                          $$->decl.insert(string($1));
                                
                                          
                                        }

                |  OPREFIX '(' IDENT ')'

                    {
                                          theDVList.push_back(string($3));
                                          PAPair thePair;
                                          thePair.second = OBJ;
                                          theRRSet.insert(theRRSet.begin(), string("OName"));
                                          theIdentTable.insert(PAIdentTable::value_type(string($3), thePair));
                                          $$ = new PAPattern;
                                          strlength = strlen("new OName(\"") + strlen($3) + strlen("\")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new OName(\"%s\")", $3);
                                          $$->code = string(buffer);
                                          $$->decl.insert(string($3));

                    }                    

                |  ODC    

                    {
                                          /* theRRSet.insert(theRRSet.begin(), string("ODCRR")); */
                                          theRRSet.insert(theRRSet.begin(), string("OVar"));
                                          $$ = new PAPattern;
                                          char count[10];
                                          sprintf(count, "%d", DCcount++);
                                          strlength = strlen("new OVar(\"_O") + strlen(count) + strlen("\")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new OVar(\"_O%s\")", count);
                                          $$->code = string(buffer);    
                                
                                          
                                        }
               ;

PrimO          :  EMPTY      

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("OSet"));
                                          theRRSet.insert(theRRSet.begin(), string("ObjList"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new OSet(new ObjList())") + 1;
                                          buffer = new char[strlength];
                                          strcpy(buffer, "new OSet(new ObjList())");
                                          $$->code = string(buffer);
                                        
                                          
                                        }

                |  INTCON     

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("OInt"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new OInt(") + strlen($1) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new OInt(%s)", $1);
                                          $$->code = string(buffer);
                                          
                                        
                                          
                                        }

                |  OID '(' INTCON  ')'
  
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("OID"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new OID(") + strlen($3) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new OID(%s)", $3);
                                          $$->code = string(buffer);
                                
                                          
                                        }

                |  STRINGCON  

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("OStr"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new OStr(\"") + strlen($1) + strlen("\")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new OStr(\"%s\")", $1);
                                          $$->code = string(buffer);
                                          
                                         
                                          
                                        }

                |  FLOATCON

                    {
                                          theRRSet.insert(theRRSet.begin(), string("OFloat"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new OFloat(\"") + strlen($1) + strlen("\")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new OFloat(\"%s\")", $1);
                                          $$->code = string(buffer);
                                          
                                          
                                        }

                |  NIL    

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("OAny"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new OAny") + 1;
                                          buffer = new char[strlength];
                                          strcpy(buffer, "new OAny");
                                          $$->code = string(buffer);
                                

                                        }

               ;


FormO          :  Func FINVOKE Obj   

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("OInvoke"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new OInvoke(") + strlen($1->code.chars()) + strlen(", ")
                                                + strlen($3->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new OInvoke(%s, %s)", $1->code.chars(), $3->code.chars());
                                          $$->code = string(buffer);
                                          set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                                
                                  
                                        }

                |  '[' Obj ',' Obj ']'    
   
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("OPair"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new OPair(") + strlen($2->code.chars()) + strlen(", ")
                                                + strlen($4->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new OPair(%s, %s)", $2->code.chars(), $4->code.chars());
                                          $$->code = string(buffer);
                                          set_union($2->decl.begin(), $2->decl.end(), $4->decl.begin(), $4->decl.end(),
                                                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                                
                                        }

                |  Obj MULT Obj
  
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("OMult"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new OMult(") + strlen($1->code.chars()) + strlen(", ")
                                                + strlen($3->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new OMult(%s, %s)", $1->code.chars(), $3->code.chars());
                                          $$->code = string(buffer);
                                          set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                                          
                                          
                                        }

                |  Obj DIV Obj
  
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("ODiv"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new ODiv(") + strlen($1->code.chars()) + strlen(", ")
                                                + strlen($3->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new ODiv(%s, %s)", $1->code.chars(), $3->code.chars());
                                          $$->code = string(buffer);
                                          set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                                        
                                          
                                        }

                |  Obj MOD Obj
  
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("OMod"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new OMod(") + strlen($1->code.chars()) + strlen(", ")
                                                + strlen($3->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new OMod(%s, %s)", $1->code.chars(), $3->code.chars());
                                          $$->code = string(buffer);
                                          set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                                        
                                        }

                |  Obj MINUS Obj
  
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("OMinus"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new OMinus(") + strlen($1->code.chars()) + strlen(", ")
                                                + strlen($3->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new OMinus(%s, %s)", $1->code.chars(), $3->code.chars());
                                          $$->code = string(buffer);
                                          set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));

                                          
                                          
                                        }

                |  Obj PLUS Obj
  
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("OPlus"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new OPlus(") + strlen($1->code.chars()) + strlen(", ")
                                                + strlen($3->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new OPlus(%s, %s)", $1->code.chars(), $3->code.chars());
                                          $$->code = string(buffer);
                                          set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));                                          
                                          
                                        }

                |  IF Bool FTHEN Obj ELSE Obj FI
  
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("OIf"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new OIf(") + strlen($2->code.chars()) + strlen(", ")
                                                + strlen($4->code.chars()) + strlen($6->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new OIf(%s, %s, %s)", $2->code.chars(), $4->code.chars(), $6->code.chars());
                                          $$->code = string(buffer);
                                          PAIdentSet temp;
                      set_union($2->decl.begin(), $2->decl.end(), $4->decl.begin(), $4->decl.end(),
                                insert_iterator<PAIdentSet> (temp, temp.begin()));
                      set_union(temp.begin(), temp.end(), $6->decl.begin(), $6->decl.end(),
                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                                          
                                        
                                        }

                |  Obj INTER Obj
  
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("OInter"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new OInter(") + strlen($1->code.chars()) + strlen(", ")
                                                + strlen($3->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new OInter(%s, %s)", $1->code.chars(), $3->code.chars());
                                          $$->code = string(buffer);
                                          set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                                          
                                        }

                |  Obj ODIF Obj
  
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("ODif"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new ODif(") + strlen($1->code.chars()) + strlen(", ")
                                                + strlen($3->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new ODif(%s, %s)", $1->code.chars(), $3->code.chars());
                                          $$->code = string(buffer);
                                          set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                                          
                                          
                                        }

                |  Obj TIMES Obj
  
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("OTimes"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new OTimes(") + strlen($1->code.chars()) + strlen(", ")
                                                + strlen($3->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new OTimes(%s, %s)", $1->code.chars(), $3->code.chars());
                                          $$->code = string(buffer);
                                          set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                                          
                                        }

                |  '(' Obj ')'        

                    { $$ = $2; }
 
                ;



/********************************************************************************
    Bool
        
    Bool Rule Expressions.
        
    Note that bool variables (BIDENT) are assumed to be of the form
        
       b, b', b'', ...
       b1, b2, b3, ...
           
********************************************************************************/

Bool            :  PrimB  { $$ = $1;}
            
                |  FormB  

                    { $$ = $1;}

                |  BIDENT 
  
                    { 
                                          theDVList.push_back(string($1));
                                          PAPair thePair;
                                          thePair.second = BOOL;
                                          theRRSet.insert(theRRSet.begin(), string("BVar"));
                                          theIdentTable.insert(PAIdentTable::value_type(string($1), thePair));
                                          $$ = new PAPattern;
                                          strlength = strlen("new BVar(\"") + strlen($1) + strlen("\")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new BVar(\"%s\")", $1);
                                          $$->code = string(buffer);
                                          $$->decl.insert(string($1));
                                         
                                        }
                                        
                |  BPREFIX '(' IDENT ')'

                    {
                                          theDVList.push_back(string($3));
                                          PAPair thePair;
                                          thePair.second = BOOL;
                                          theRRSet.insert(theRRSet.begin(), string("BName"));
                                          theIdentTable.insert(PAIdentTable::value_type(string($3), thePair));
                                          $$ = new PAPattern;
                                          strlength = strlen("new BName(\"") + strlen($3) + strlen("\")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new BName(\"%s\")", $3);
                                          $$->code = string(buffer);
                                          $$->decl.insert(string($3));

                    }

                |  BDC    

                    {
                                          /* theRRSet.insert(theRRSet.begin(), string("BDCRR")); */
                                          theRRSet.insert(theRRSet.begin(), string("BVar"));
                                          $$ = new PAPattern;
                                          char count[10];
                                          sprintf(count, "%d", DCcount++);
                                          strlength = strlen("new BVar(\"_B") + strlen(count) + strlen("\")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new BVar(\"_B%s\")", count);
                                          $$->code = string(buffer);              
                                          
                                          
                                          
                                        }

 
               ;


PrimB          :  TRUEv  

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("BPrimitive"));
                                          $$ = new PAPattern;
                                          buffer = new char[strlen("new BPrimitive(T)") + 1];
                                          strcpy(buffer, "new BPrimitive(T)");
                                          $$->code = string(buffer);
                                          
                                          
                                          
                                        }

                |  FALSEv 

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("BPrimitive"));
                                          $$ = new PAPattern;
                                          buffer = new char[strlen("new BPrimitive(F)") + 1];
                                          strcpy(buffer, "new BPrimitive(F)");
                                          $$->code = string(buffer);
                                
                                          
                                        }
 
                ;

FormB           :  Pred PINVOKE Obj 

                    { 
                                          theRRSet.insert(theRRSet.begin(), string("BInvoke"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new BInvoke(") + strlen($1->code.chars()) + strlen(", ")
                                                + strlen($3->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new BInvoke(%s, %s)", $1->code.chars(), $3->code.chars());
                                          $$->code = string(buffer);
                                          set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                                        
                                        }

                |  Obj PEQUAL Obj 
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("BEqu"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new BEqu(") + strlen($1->code.chars()) + strlen(", ")
                                                + strlen($3->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new BEqu(%s, %s)", $1->code.chars(), $3->code.chars());
                                          $$->code = string(buffer);
                                          set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          

                                        }
                |  Obj NE Obj
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("BNotEqual"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new BNotEqual(") + strlen($1->code.chars()) + strlen(", ")
                                                + strlen($3->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new BNotEqual(%s, %s)", $1->code.chars(), $3->code.chars());
                                          $$->code = string(buffer);
                                          set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                                         
                                        }
                |  Obj LESS Obj
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("BLT"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new BLT(") + strlen($1->code.chars()) + strlen(", ")
                                                + strlen($3->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new BLT(%s, %s)", $1->code.chars(), $3->code.chars());
                                          $$->code = string(buffer);
                                          set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                                        
                                        }
                |  Obj LANGLE Obj
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("BLT"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new BLT(") + strlen($1->code.chars()) + strlen(", ")
                                                + strlen($3->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new BLT(%s, %s)", $1->code.chars(), $3->code.chars());
                                          $$->code = string(buffer);
                                          set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                                         
                                        }
                |  Obj LE Obj 
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("BLE"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new BLE(") + strlen($1->code.chars()) + strlen(", ")
                                                + strlen($3->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new BLE(%s, %s)", $1->code.chars(), $3->code.chars());
                                          $$->code = string(buffer);
                                          set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                                         
                                        }
                |  Obj GREATER Obj 
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("BGT"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new BGT(") + strlen($1->code.chars()) + strlen(", ")
                                                + strlen($3->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new BGT(%s, %s)", $1->code.chars(), $3->code.chars());
                                          $$->code = string(buffer);
                                          set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                                        
                                        }
                |  Obj RANGLE Obj
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("BGT"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new BGT(") + strlen($1->code.chars()) + strlen(", ")
                                                + strlen($3->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new BGT(%s, %s)", $1->code.chars(), $3->code.chars());
                                          $$->code = string(buffer);
                                          set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                                        
                                        }
                |  Obj GE Obj
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("BGE"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new BGE(") + strlen($1->code.chars()) + strlen(", ")
                                                + strlen($3->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new BGE(%s, %s)", $1->code.chars(), $3->code.chars());
                                          $$->code = string(buffer);
                                          set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                                        

                                        }
                |  Bool BAND Bool
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("BEqu"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new BEqu(") + strlen($1->code.chars()) + strlen(", ")
                                                + strlen($3->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new BEqu(%s, %s)", $1->code.chars(), $3->code.chars());
                                          $$->code = string(buffer);
                                          set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                                         
                                        }
                |  Bool BOR Bool
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("BOr"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new BOr(") + strlen($1->code.chars()) + strlen(", ")
                                                + strlen($3->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new BOr(%s, %s)", $1->code.chars(), $3->code.chars());
                                          $$->code = string(buffer);
                                          set_union($1->decl.begin(), $1->decl.end(), $3->decl.begin(), $3->decl.end(),
                                                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                                        

                                        }
                |  NOT '(' Bool ')'
                    { 
                                          theRRSet.insert(theRRSet.begin(), string("BNot"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new BNot(") + strlen($3->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new BNot(%s)", $3->code.chars());
                                          $$->code = string(buffer);
                                          set_union($3->decl.begin(), $3->decl.end(), $3->decl.begin(), $3->decl.end(),
                                                                insert_iterator<PAIdentSet> ($$->decl, $$->decl.begin()));
                                          
                                         

                                        }

                |  '(' Bool ')'     

                    { $$ = $2;}

                ;

kType           :  TIDENT 

                    { 
                                          theRRTypeSet.insert(theRRTypeSet.begin(), string("TVar"));
                                          $$ = new PAPattern;
                                          
                                          strlength = strlen("new TVar(\"") + strlen($1) + strlen("\")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new TVar(\"%s\")", $1);
                                          $$->code = string(buffer);
                        
                                        }


                |  TDC    

                    {
                                          theRRTypeSet.insert(theRRTypeSet.begin(), string("TDC"));
                                          $$ = new PAPattern;
                                          
                                          strlength = strlen("new TDC(") + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new TDC()");
                                          $$->code = string(buffer);       
                                
                                        }

                |  '[' kType ',' kType ']'

                    {
                                          theRRTypeSet.insert(theRRTypeSet.begin(), string("TPair"));
                                          $$ = new PAPattern;
                                          
                                          strlength = strlen("new TPair(,") + strlen($2->code.chars()) + strlen($4->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new TPair(%s,%s)", $2->code.chars(), $4->code.chars());
                                          $$->code = string(buffer);  
                                        
                                          
                                        }

                |  '{' kType '}'

                    {
                                          theRRTypeSet.insert(theRRTypeSet.begin(), string("TSet"));
                                          $$ = new PAPattern;
                                          
                                          strlength = strlen("new TSet(") + strlen($2->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new TSet(%s)", $2->code.chars());
                                          $$->code = string(buffer);    
                                
                                        }
                                        
                |  DPO kType DPC

                    { 
                                          theRRTypeSet.insert(theRRTypeSet.begin(), string("TBag"));
                                          $$ = new PAPattern;
                                          
                                          strlength = strlen("new TBag(") + strlen($2->code.chars()) + strlen(")") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new TBag(%s)", $2->code.chars());
                                          $$->code = string(buffer);    
                                        
                                          
                                        }

                |  INT

                    { 
                                          theRRTypeSet.insert(theRRTypeSet.begin(), string("TInt"));
                                          $$ = new PAPattern;
                                          
                                          strlength = strlen("new TInt()") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new TInt()");
                                          $$->code = string(buffer);    
                                        
                                        }

                |  KFLOAT

                    { 
                                          theRRTypeSet.insert(theRRTypeSet.begin(), string("TFlt"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new TFlt()") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new TFlt()");
                                          $$->code = string(buffer);    
                                
                                        }

                |  KSTRING

                    { 
                                          theRRTypeSet.insert(theRRTypeSet.begin(), string("TStr"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new TStr()") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new TStr()");
                                          $$->code = string(buffer);    

                                        }

                |  KCHAR
                    {
                                          theRRTypeSet.insert(theRRTypeSet.begin(), string("TChar"));
                                          $$ = new PAPattern;
                                          strlength = strlen("new TChar()") + 1;
                                          buffer = new char[strlength];
                                          sprintf(buffer, "new TChar()");
                                          $$->code = string(buffer);    
                                         
                    }
 
                ;


%%
                                  
int CKerror (char *s)  {
  
  cerr << endl <<  s << " found at line: " << lineno << " (" << CKtext << ")" << " of COKO RuleBlock.\n\n";
  return 0;
}
                                        

                                                                                
