#ifndef _PAPARSER_H_
#define _PAPARSER_H_

#include <fstream.h>
//EDDIE_SUMMER_00(commented out)
//#include <libc.h>
#include "mstring.h"
#include <list.h>
#include <map.h>
#include <deque.h>
#include <stack.h>
#include <set.h>
#include <pair.h>

typedef enum {RMORE_LEFT, RMORE_RIGHT, REQUAL, RUNKNOWN} PARuleType;
typedef enum {FUNC, PRED, OBJ, BOOL, INDX} PAIdentType;
typedef list<string> PACode;
typedef set<string, less<string> > PAIdentSet;
typedef map<string, PARuleType, less<string> > PARuleTable;
typedef set<string, less<string> > DEPSet;
typedef pair<DEPSet, PAIdentType > PAPair;
typedef map<string, PAPair, less<string> > PAIdentTable;
typedef stack<PAIdentTable> PAStack;

typedef struct {PACode decl; PACode code; } PAUseList;
typedef struct {string decl; string code;  } PAUse;
typedef struct {PACode code; } PABody;

// added precond member to signify if the rule has any preconditions
typedef struct {string code; PARuleType type; bool precond;} PARule;
typedef struct {string code; string pcode; string pcode_w;} PAStmt;
typedef struct {PAIdentSet decl; string code;} PAPattern;
//typedef struct {string pcode;} PAInfer;

class PARuleBlock {
protected:

  //DJA SUMMER 2001 added _uses_codeCode and _dat_memCode
  string _name;
  PACode _includeCode;
  PACode _dat_memCode;
  PACode _uses_codeCode;
  PACode _declarationsCode;
  PACode _bodyCode;
  PACode _prologCode;

public:
  PARuleBlock(string name, PACode include, PACode dat_mem, PACode uses_code, PACode declarations, PACode body, PACode pcode);
  const char *Name(void);
  void Emit(ofstream&, ofstream&, ofstream&, ofstream&, ofstream&, int, int);
};

#endif
