/*
 * Copyright 1995, Brown University, Providence, RI
 *
 * Permission to use and modify this software and its documentation for
 * any purpose other than its incorporation into a commercial product is
 * hereby granted without fee.  Permission to copy and distribute this
 * software and its documentation only for non-commercial use is also
 * granted without fee, provided, however, that the above copyright notice
 * appear in all copies, that both that copyright notice and this permission
 * notice appear in supporting documentation, that the name of Brown
 * University not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission,
 * and that the person doing the distribution notify Brown University of
 * such distributions outside of his or her organization. Brown University
 * makes no representations about the suitability of this software for
 * any purpose.  It is provided "as is" without express or implied warranty.
 * Brown University requests notification of any modifications to this
 * software or its documentation.
 *
 * Send the following redistribution information:
 *
 *	Name:
 *	Organization:
 *	Address (postal and/or electronic):
 *
 * To:
 *	Software Librarian
 *	Computer Science Department, Box 1910
 *	Brown University
 *	Providence, RI 02912
 *
 *		or
 *
 *	brusd@cs.brown.edu
 *
 * We will acknowledge all electronic notifications.


//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon S. Lee (jl@cs.brown.edu)
//  FILE: PACL.l 
//  PROJ: COKO Compiler
//  DATE: 8/97
//
//
//////////////////////////////////////////////////////////////////////////////

*/

%{
#include <stdlib.h>
#include <string.h>
#include <fstream.h>
//#include <libc.h>
#include "PParser.h"

extern int CKparse();
extern FILE *CKin;
extern PPropertyBlock *theBlock;
extern void fatal(char *, char *);

char *filenameH;
char *filenameC;

static int myinput(char *buf, int max);

#undef YY_INPUT
#define YY_INPUT(buf, result, max) (result = myinput(buf, max))

%}


%%
[^ \n\t\-\+]+".pr"              { 
                       ofstream foutH; ofstream foutC;

					   int strlength;

					   if((CKin = fopen(CLtext, "rt")) == NULL) {
                        fatal("Unable to open coko property block file", CLtext);
					   }

					   if(CKparse() == 0) {
						 strlength = strlen(theBlock->Name()) + strlen("Property") + strlen(".h") + 1;
						 filenameH = new char[strlength];
						 sprintf(filenameH, "%sProperty.h", theBlock->Name());
						
                                                 foutH.open(filenameH, ios::trunc|ios::out);
                                                 strlength = strlen(theBlock->Name()) + strlen("Property") + strlen(".cc") + 1;
						 filenameC = new char[strlength];
						 sprintf(filenameC, "%sProperty.cc", theBlock->Name());

						 foutC.open(filenameC, ios::trunc|ios::out);


						 theBlock->Emit(foutH,foutC);
						 foutH.close();
                                                 foutC.close();
						 delete filenameH;
                                                 delete filenameC;
						 delete theBlock;
						 theBlock = NULL;
						 filenameH = NULL;
	                                         filenameC = NULL;
				   }
					   else fatal("Parse error in coko property block file", CLtext);
                     }

[^ \t\n]+            { 
                     }
%%
char **targv;
char **arglim;

static unsigned offset = 0;

int
myinput(char *buf, int max)
{
  int len, copylen;
 
  if(targv >= arglim)
	return 0;
  
  len = strlen(*targv) - offset;
  if(len >= max)
	copylen = max - 1;
  else
	copylen = len;
  if(len > 0)
	memcpy(buf, targv[0] + offset, copylen);
  if(targv[0][offset + copylen] == '\0') {
	buf[copylen] = ' ';
	copylen++;
	offset = 0;
	targv++;
  }
  return copylen;
}

int CLwrap() { return 1; }
