//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Marina Zlatkina
//  FILE: MatchProperty.H
//  PROJ: COKO
//  DATE: 8/2001                                                            
//
// SYNOPSIS
//  Class that matches the variables in the arguments on the RHS of the rule
//  with the arguments provided at runtime.
//  
//////////////////////////////////////////////////////////////////////////////
#ifndef _MATCHPROPERTY_H
#define _MATCHPROPERTY_H

#include "Property.H"
#include "PCPattern.H"
#include "NonTypeArgs.H"

class CState;

class MatchProperty : public Property{

public:
  MatchProperty(NonTypeArgs *);
  // constructor

  NonTypeArgs * isTrue(CState *, NonTypeArgs *);
  // determines if pattern can be matched to the NonTypeArgs object given
  // at runtime

private:  
  NonTypeArgs *pattern;
  // the pattern of all the arguments to the property

};

#endif
