#ifndef _DPAINTWINDOW_H_
#define _DPAINTWINDOW_H_

#include <qwidget.h>
#include <qpainter.h>
#include <qgroupbox.h>
#include <qpopupmenu.h>
#include "KONonType.H"
#include "DEVisNodeInfo.H"
#include "SymbolList.H"
#include "VC.H"

class DWhichList;
class MyMainWindow;
class DScrollWidget;

class DPaintWindow: public QWidget
{
  Q_OBJECT
public:
  //The following used to be the code, but I had to get rid of GroupBox because it seemed to crash on certain monitors with inadequate video cards (the machines where you get "EXTENSION RENDER not found error"
  //DPaintWindow(QPopupMenu* view = 0, int index = 0, MyMainWindow* win = 0, DGroupBox* grandpa=0, const char *name=0);
  DPaintWindow(QPopupMenu* view = 0, int index = 0, MyMainWindow* win = 0, DScrollWidget* grandpa=0, const char *name=0);
  void setCurrent(NonType *curr);
  void setImportantValues(SymbolList* sym, char* name);
  void generateTreeDesc(NonType*, int);
  int findNumExternalNodes(NonType*);
  int findNumNodes(NonType*);
  int drawNode(NonType*, int, int);
  int twoToThe(int);
  bool close(bool);
  void mousePressEvent(QMouseEvent* e);
  int findCondtainingIndex(int,int);
  void updateWhichList(DWhichList*,NonType*,int);
  NonType* findNodeFromIndex(int,NonType*,DWhichList*);
  float getZoomFactor();
  const char* getName();
  
public slots:
  void zoom_in();
  void zoom_out();
  void isolate();

private:
  QPopupMenu* _view;
  DScrollWidget* _grandpaWid;
  int _index;
  void paintEvent(QPaintEvent*);
  char* shortenString(char*);
  const char* _name;
  QPainter *paint;
  char* execName;
  NonType *current;
  SymbolList* _sym;
  int* treeDesc;
  int curr_x;
  int x_inc;
  int numNodes;
  DVisNodeInfo** nodes;
  int nodeCounter;
  int globalCounter;
  int indexToIsolate;
  int mouse_x;
  int mouse_y;
  MyMainWindow* vis;
  float _zoomFactor;
};

#endif
