//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon Suk Lee (jl) 
//  FILE: CondList.H
//  PROJ: COKO
//  DATE: 10/97                                                             
//
// SYNOPSIS
//  Classes for NonType List.
//  
//////////////////////////////////////////////////////////////////////////////


#ifndef _NONTYPELIST_H_
#define _NONTYPELIST_H_

#include <strings.h>
#include <stdlib.h>
#include <iostream.h>
#include "KONonType.H"

class NonTypeNode
{
public:
  NonType * _value;
  NonTypeNode * _next;

  NonTypeNode(NonType * c);
  // Constructor

  ~NonTypeNode();
  // Destructor

};

class NonTypeList
{
private:
  NonTypeNode * _iterator;
  NonTypeNode * _head;
  NonTypeNode * _tail;

public:

  NonTypeList();
  // Constructor
  
  ~NonTypeList();
  // Destructor

  void insert(NonType* a);
  //  Insert a new node with _value = a to the list

  int pop();
  // Pop off a front node from the list
  // Return success value of the pop.

  NonType* top();
  // Returns _value of the top node.

  int empty();
  // Is the list empty?

  void initIterator();
  // Initialize _iterator
  // This method is used with getValue method

  NonType* iteratorValue();
  // Returns _value of the node that _iterator is pointing to.

  NonType* getValue();
  // Returns _value of the node that _iterator is pointing to.
  // After a call to this method, _iterator will point to the next node.
  // One can call this methods repeatly to get the _value of all the nodes.
  // However, initIterator has to be called before the initial call to this 
  // method.  

};

#endif

