#define SP_TYPE_VARIABLE 1
#define SP_TYPE_INTEGER 2
#define SP_TYPE_ATOM 3
#define SP_TYPE_FLOAT 4
#define SP_TYPE_COMPOUND 5

#define SP_initialize(Argc,Argv,BootPath) glue_initialize(Argc,Argv,BootPath,sp_pre_linkage,sp_pre_map)

typedef unsigned long int SP_term;
typedef char* SP_pred_ref;
typedef long SP_qid;
typedef int SP_term_ref;
typedef void (SP_MainFun) ();
typedef void (SP_VoidFun) (void);

extern "C"
{

extern SP_VoidFun *sp_pre_linkage[];
extern char *sp_pre_map[];

extern SP_term_ref SP_new_term_ref (void);
extern SP_term_ref SP_new_term_refs (int);

extern int glue_initialize (int, char **, char *, SP_MainFun **, char **);

extern int SP_load (char *);
extern void SP_restart (void);
extern SP_pred_ref SP_predicate (char *,long,char *);
extern int SP_term_type (SP_term);

extern int SP_query (SP_pred_ref, ...);

extern int SP_put_variable (SP_term_ref);
extern int SP_put_integer (SP_term_ref, long);
extern int SP_put_string (SP_term_ref, char *);
extern int SP_put_list_chars(SP_term_ref, SP_term_ref,char *);
extern int SP_put_number_chars (SP_term_ref, char *);
extern int SP_put_functor (SP_term_ref, unsigned long, int);
extern int SP_cons_functor (SP_term_ref term, unsigned long name, int arity, ...);

extern unsigned long SP_atom_from_string (char *);

extern int SP_get_arg (int, SP_term_ref, SP_term_ref);
extern int SP_get_list (SP_term_ref, SP_term_ref, SP_term_ref);
extern int SP_get_string (SP_term_ref, char **);
extern int SP_get_list_chars (SP_term_ref, char **);

extern int SP_put_term (SP_term_ref, SP_term_ref);
extern int SP_close_query (SP_qid);


}

