/*
 * Copyright 1994, Brown University, Providence, RI
 *
 * Permission to use and modify this software and its documentation for
 * any purpose other than its incorporation into a commercial product is
 * hereby granted without fee.  Permission to copy and distribute this
 * software and its documentation only for non-commercial use is also
 * granted without fee, provided, however, that the above copyright notice
 * appear in all copies, that both that copyright notice and this permission
 * notice appear in supporting documentation, that the name of Brown
 * University not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission,
 * and that the person doing the distribution notify Brown University of
 * such distributions outside of his or her organization. Brown University
 * makes no representations about the suitability of this software for
 * any purpose.  It is provided "as is" without express or implied warranty.
 * Brown University requests notification of any modifications to this
 * software or its documentation.
 *
 * Send the following redistribution information:
 *
 *      Name:
 *      Organization:
 *      Address (postal and/or electronic):
 *
 * To:
 *      Software Librarian
 *      Computer Science Department, Box 1910
 *      Brown University
 *      Providence, RI 02912
 *
 *              or
 *
 *      brusd@cs.brown.edu
 *
 * We will acknowledge all electronic notifications.
 */

/* -*-Mode:c++-*- */

/*
//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon S. Lee (jl)					 	    
//  FILE: KONameUnion.H
//  PROJ: COKO
//  DATE: 6/96		                                                    
//
// SYNOPSIS
//  Union of PredName, FuncName, ObjName, BoolName.
//  This class is used in Myname() methods.
//  Myname() returns union type of those four enum types with a tag.  
//
//////////////////////////////////////////////////////////////////////////////
*/
#ifndef KOLA_NAMEUNION_HEADER
#define KOLA_NAMEUNION_HEADER

#include "KGlobals.H"

class NameUnion {
public:
  NameTag tag;
  union {
	FuncName fn;
	PredName pn;
	ObjName on;
	BoolName bn;
  };
  
  NameUnion(NameTag t, FuncName content_p);
  // constructor
  
  NameUnion(NameTag t, PredName content_p);
  // constructor
  
  NameUnion(NameTag t, ObjName content_p);
  // constructor
  
  NameUnion(NameTag t, BoolName content_p);
  // constructor
};

#endif


