
/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Mitch Cherniack (mfc)
//        Xiaoyu Wang (wangxy)
//  FILE: KOTBang.C 
//  PROJ: COKO, KOLA
//  DATE: 9/00		                                                    
//
//////////////////////////////////////////////////////////////////////////////

#include "KOTBang.H"
extern "C" { int atio(const char *s); }
  
//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  TBang
// Parameters: (TagExp* te1, TagExp* te2)
//
// Constructor.
//
/////////////////////////////////////////////////////////////////////////////

TBang::TBang(TagExp* te1, TagExp* te2):TagExp(TAGEXP_BANG, "!" )
{
    one = te1;
    two = te2;
    variableNum = 0;
}

//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  TBang
// Parameters:(TBang& other)
//
// Copy Constructor
//
/////////////////////////////////////////////////////////////////////////////

TBang::TBang(const TBang& other):TagExp((TagExp &)other)
{
    one = other.One()->Copy();
    two = other.Two()->Copy();
    variableNum = other.getVariableNum();
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: ~TBang
// Parameters: ()
//
// Destructor
//
/////////////////////////////////////////////////////////////////////////////

TBang::~TBang()
{
  delete one;
  delete two;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: Copy
// Parameters: ()
//
// return the copy of this tagexp
//
/////////////////////////////////////////////////////////////////////////////

TagExp* TBang::Copy() const
{
  TBang* temp = new TBang (*this);
  temp->setVariableNum(variableNum);
  return temp;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: deepeq
// Parameters: (NonType *)
//
// does nothing
//
/////////////////////////////////////////////////////////////////////////////

int TBang::deepeq(NonType* other)
{
  return T;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: Myname
// Parameters: ()
//
// does nothing now
//
////////////////////////////////////////////////////////////////////////////

NameUnion* TBang::Myname()
{

  return NULL;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name:  nextChild
// Parameters: ()
//
// Return "currChild++"th child.
// When currChild is equal to the number of children
// (when currChild is the last child), it returns NULL.
//
/////////////////////////////////////////////////////////////////////////////

NonType* TBang::nextChild()
{
  if(currChild == 0){
    currChild++;
    return one;
  } else { 
    if(currChild == 1){
      currChild++;
      return two;
    } else { 
      return NULL;
    }
  }
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: representation
// Parameters: ()
//
/////////////////////////////////////////////////////////////////////////////

char * TBang::representation()
{
  char *pr1 = One()->representation();
  char *pr2 = Two()->representation();
  
  char *res = new char[strlen(pr1)+strlen(pr2)+strlen(" ! ")+1];
  sprintf(res, "%s ! %s", pr1, pr2);
  delete [] pr1;
  delete [] pr2;
  return res;
}


////////////////////////////////////////////////////////////////////////////
//
// Function Name: transform
// Parameters: (CState*)
//
// Return corresponding NonType object.
//
////////////////////////////////////////////////////////////////////////////

NonType* TBang::transform(CState* s)
{
    return this;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: compares
// Parameters: (NonType*, CState*)
//
// compare two trees
//
////////////////////////////////////////////////////////////////////////////

int TBang::compares(NonType* nt, CState* a)
{
    return T;
}

//////////////////////////////////////////////////////////////////////////
//
// Function Name: compareSTM
// Parameter: (NonType*, CState*)
//
// Check for match between two NonType tree...
//
// Does nothing now, just return T, 
//
//////////////////////////////////////////////////////////////////////////

int TBang::compareSTM(NonType* nt, CState* a)
{
    return T;
}

///////////////////////////////////////////////////////////////////////////
//
// Function Name: replaceChild
// Parameters: (NonType*, int)
//
// Replace a child of a given tree..
//
///////////////////////////////////////////////////////////////////////////

void TBang::replaceChild(NonType* child, int which_child)
{
  if(which_child == 1)
    setOne(child);
  else if(which_child == 2)
    setTwo(child);
}


///////////////////////////////////////////////////////////////////////////
//
// Function Name: prolog
// Parameters:()
//
//////////////////////////////////////////////////////////////////////////

char* TBang::prolog()
{
  return NULL;
}

#ifdef _PROLOG_
///////////////////////////////////////////////////////////////////////////
//
// Function Name: sp_prolog
// Parameters:()
//
///////////////////////////////////////////////////////////////////////////

SP_term_ref TBang::sp_prolog()
{
  return NULL;
}
#endif //_PROLOG_

