/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Mitch Cherniack (mfc)
//        Xiaoyu Wang (wangxy)
//  FILE: KOTElem.C 
//  PROJ: COKO, KOLA
//  DATE: 9/00		                                                    
//
//////////////////////////////////////////////////////////////////////////////

#include "KOTElem.H"
extern "C" { int atio(const char *s); }
  
//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  TElem
// Parameters: (OStr* str)
//
// Constructor.
//
/////////////////////////////////////////////////////////////////////////////

TElem::TElem(OStr* str):Tag(TAG_ELEM, "%" )
{
  one = str;
  variableNum = 0;
}

//////////////////////////////////////////////////////////////////////////////
//
// Function Name: TElem 
// Parameters:(TElem& other)
//
// Copy Constructor
//
/////////////////////////////////////////////////////////////////////////////

TElem::TElem(const TElem& other):Tag((Tag &)other)
{
  one =(OStr *)other.One()->Copy();
  variableNum = other.getVariableNum();
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: ~TElem
// Parameters: ()
//
// Destructor
//
/////////////////////////////////////////////////////////////////////////////

TElem::~TElem()
{
    delete one;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: Copy
// Parameters: ()
//
// return the copy of this tagexp
//
/////////////////////////////////////////////////////////////////////////////

Tag* TElem::Copy() const
{
  TElem* temp = new TElem (*this);
  temp->setVariableNum(variableNum);
  return temp;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: deepeq
// Parameters: (NonType *)
//
// does nothing now
//
/////////////////////////////////////////////////////////////////////////////

int TElem::deepeq(NonType* other)
{
  return T;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: Myname
// Parameters: ()
//
// does nothing now
//
////////////////////////////////////////////////////////////////////////////

NameUnion* TElem::Myname()
{
  return NULL;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name:  nextChild
// Parameters: ()
//
// Return "currChild++"th child.
// When currChild is equal to the number of children
// (when currChild is the last child), it returns NULL.
//
/////////////////////////////////////////////////////////////////////////////

NonType* TElem::nextChild()
{
    if(currChild == 0)
      {
        currChild++;
        return one;
      }
    else  return NULL;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: representation
// Parameters: ()
//
//
/////////////////////////////////////////////////////////////////////////////

char * TElem::representation()
{
    char *pr = one->representation();
    char *res = new char[strlen(pr)+strlen("( )") + strlen("%") + 1];
    sprintf(res, "(%s %s)","%",  pr);
    delete [] pr;
    return res;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: transform
// Parameters: (CState*)
//
// Return corresponding NonType object.
//
// Now it does nothing just return itself 
//
////////////////////////////////////////////////////////////////////////////

NonType* TElem::transform(CState* s)
{
  return this;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: compares
// Parameters: (NonType*, CState*)
//
// compare two trees
//
////////////////////////////////////////////////////////////////////////////

int TElem::compares(NonType* nt, CState* a)
{
  return T;
}

//////////////////////////////////////////////////////////////////////////
//
// Function Name: compareSTM
// Parameter: (NonType*, CState*)
//
// Check for match between two NonType tree...
//
//////////////////////////////////////////////////////////////////////////

int TElem::compareSTM(NonType* nt, CState* a)
{
  return T;
}

///////////////////////////////////////////////////////////////////////////
//
// Function Name: replaceChild
// Parameters: (NonType*, int)
//
// Replace a child of a given tree..
//
///////////////////////////////////////////////////////////////////////////

void TElem::replaceChild(NonType* child, int which_child)
{
  if(which_child == 1)
    setOne(child);
}

///////////////////////////////////////////////////////////////////////////
//
// Function Name: prolog
// Parameters:()
//
//////////////////////////////////////////////////////////////////////////

char* TElem::prolog()
{
  return NULL;
}

#ifdef _PROLOG_
///////////////////////////////////////////////////////////////////////////
//
// Function Name: sp_prolog
// Parameters:()
//
// Does nothing, return NULL
//
///////////////////////////////////////////////////////////////////////////

SP_term_ref TElem::sp_prolog()
{
  return NULL;
}
#endif //_PROLOG_

