
/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Mitch Cherniack (mfc)
//        Xiaoyu Wang (wangxy)
//  FILE: KOTPlus.C 
//  PROJ: COKO, KOLA
//  DATE: 9/00		                                                    
//
//////////////////////////////////////////////////////////////////////////////

#include "KOTPlus.H"
extern "C" { int atio(const char *s); }
  
//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  TPlus
// Parameters: (TagExp* te)
//
// Constructor.
//
// needs refine later...
//
/////////////////////////////////////////////////////////////////////////////

TPlus::TPlus(TagExp* te):TagExp(TAGEXP_PLUS, "PLUS")
{
    one = te;
    variableNum = 0;
}

//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  TPlus
// Parameters:(TPlus& other)
//
// Copy Constructor
//
/////////////////////////////////////////////////////////////////////////////

TPlus::TPlus(const TPlus& other):TagExp((TagExp &)other)
{
    one = other.One()->Copy();
    variableNum = other.getVariableNum();
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: ~TPlus
// Parameters: ()
//
// Destructor
//
/////////////////////////////////////////////////////////////////////////////

TPlus::~TPlus()
{
    delete one;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: Copy
// Parameters: ()
//
// return the copy of this tagexp
//
/////////////////////////////////////////////////////////////////////////////

TagExp* TPlus::Copy() const
{
  TPlus* temp = new TPlus (*this);
  temp->setVariableNum(variableNum);
  return temp;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: deepeq
// Parameters: (NonType *)
//
// does nothing
//
/////////////////////////////////////////////////////////////////////////////

int TPlus::deepeq(NonType* other)
{
  return T;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: Myname
// Parameters: ()
//
// return a union type, NameUnion.
// since NonType has 6 different sub-classes....
//
////////////////////////////////////////////////////////////////////////////

NameUnion* TPlus::Myname()
{
      return NULL;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name:  nextChild
// Parameters: ()
//
// Return "currChild++"th child.
// When currChild is equal to the number of children
// (when currChild is the last child), it returns NULL.
//
/////////////////////////////////////////////////////////////////////////////

NonType* TPlus::nextChild()
{
    if(currChild == 0)
      {
        currChild++;
        return one;
      }
    else  return NULL;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: representation
// Parameters: ()
//
/////////////////////////////////////////////////////////////////////////////

char * TPlus::representation()
{
    char *pr = one->representation();
    char *res = new char[strlen(pr)+strlen("PLUS ()")+1];
    sprintf(res, "PLUS (%s)", pr);
    delete [] pr;
    return res;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: transform
// Parameters: (CState*)
//
// Return corresponding NonType object.
//
////////////////////////////////////////////////////////////////////////////

NonType* TPlus::transform(CState* s)
{
    return this;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: compares
// Parameters: (NonType*, CState*)
//
// compare two trees
//
////////////////////////////////////////////////////////////////////////////

int TPlus::compares(NonType* nt, CState* a)
{
    return T;
}

//////////////////////////////////////////////////////////////////////////
//
// Function Name: compareSTM
// Parameter: (NonType*, CState*)
//
// Check for match between two NonType tree...
//
// Does nothing now, just return T, 
//
//////////////////////////////////////////////////////////////////////////

int TPlus::compareSTM(NonType* nt, CState* a)
{
    return T;
}


///////////////////////////////////////////////////////////////////////////
//
// Function Name: replaceChild
// Parameters: (NonType*, int)
//
// Replace a child of a given tree..
//
//  seems useless, delete it.  
//
///////////////////////////////////////////////////////////////////////////

void TPlus::replaceChild(NonType* child, int which_child)
{
  if(which_child == 1)
    setOne(child);
}


///////////////////////////////////////////////////////////////////////////
//
// Function Name: prolog
// Parameters:()
//
// Does nothing, return NULL
//
//////////////////////////////////////////////////////////////////////////

char* TPlus::prolog()
{
    return NULL;
}

#ifdef _PROLOG_
///////////////////////////////////////////////////////////////////////////
//
// Function Name: sp_prolog
// Parameters:()
//
// Does nothing, return NULL
//
///////////////////////////////////////////////////////////////////////////

SP_term_ref TPlus::sp_prolog()
{
    return NULL;
}
#endif //_PROLOG_

