
/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Mitch Cherniack(mfc) 
//        Xiaoyu Wang(wangxy) 
//  FILE: KOTag.C 
//  PROJ: COKO, KOLA
//  DATE: 9/00		                                                    
//
// SYNOPSIS
//  The class of containable objects.  (Includes
//  integers, strings, as well as pairs and sets of 
//  Objects).  Also should include user defined 
//  typed objects.  This class and its subclasses
//  construct object that are used in KOLA trees.
//  These should be distinguished from
//  OResults which are used in expression trees.
//  KOLA trees are used for optimization.  Expression
//  trees are used to describe the result of a query denoted 
//  by a KOLA tree.
//  
//////////////////////////////////////////////////////////////////////////////

#include "KOTag.H"

//////////////////////////////////////////////////////////////////////////////
//
// Function Name: Tag
// Parameters: (TObj* t, TagName tn,  char *nm)
//
// Constructor.
//
//////////////////////////////////////////////////////////////////////////////

Tag::Tag(TagName tn, char* n)
{
  myname = tn;
  if(n == NULL) namestring = NULL;
  else {
    namestring = new char[strlen(n)+1];
    sprintf(namestring, "%s", n);
  }
  variableNum = 0;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name:  Tag
//
// Parameters: (const Tag& other)
//
/////////////////////////////////////////////////////////////////////////////

Tag::Tag(const Tag& other)
{
  myname = other.Identity();
  
  namestring = new char[strlen(other.Name())+1];
  sprintf(namestring, "%s", other.Name());
  variableNum = other.getVariableNum();
}

//////////////////////////////////////////////////////////////////////////////
//
// Function Name: ~Tag
// Parameters: ()
//
// Destructor.
//
//////////////////////////////////////////////////////////////////////////////

Tag::~Tag()
{ 
  if(namestring) delete[] namestring;
}

//////////////////////////////////////////////////////////////////////////////
//
// Function Name: sql
// Parameters: ()
//
// Return SQL representation of result of invoking this on o
//
//////////////////////////////////////////////////////////////////////////////

char* Tag::sql()
{
    return NULL;
}

//////////////////////////////////////////////////////////////////////////////
//
// Function Name: oql
// Parameters: ()
//
// Return oql representation of result of invoking this on o
//
//////////////////////////////////////////////////////////////////////////////

char * Tag::oql()
{
     return NULL;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: tag
// Parameter: ()
//
// Symbolic simplification of this. Eventually, this method will replace
// "object" presently only defined with _OSTORE_ flag set
//
//////////////////////////////////////////////////////////////////////////////

Tag* Tag::tag()
{
  return Copy();
} 



