
/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Mitch Cherniack (mfc)
//        Xiaoyu Wang (wangxy)					 	    
//  FILE: KOTagExpLink.H 
//  PROJ: COKO, KOLA
//  DATE: 5/97		                                                    
//
// SYNOPSIS
//  TagExpression link.  FOrm a chain of members to a set.
//
//////////////////////////////////////////////////////////////////////////////

#ifndef KOLA_TAGEXPLINK_HEADER
#define KOLA_TAGEXPLINK_HEADER 

#include "KGlobals.H"
#include <string.h>
#include "PCState.H"
#include "KOTagExpList.H"
#include "KOTagExp.H"

class TagExpLink
{
public:
  TagExpLink (TagExp* o);
  //  Constructor
  
  TagExpLink (const TagExpLink & other);
  //  Copy Constructor
  
  ~TagExpLink ();
  //  Destructor
  
  TagExp* tagexp () const { return _tagexp; }
  //  What tagexpression is kept at this link?
  
  void Next (TagExpLink* te) {next = te;}
  //  Set next to o.
  
  TagExpLink* Next () const {return next;}
  //  Selector.  What is next TagExpLink?  (NULL if none)
	  
  char* prolog ();
  // return string representation in prolog term

  char* representation ();
  //  return te -> representation ()

  char *sql ();
  // Return the SQL string equivalent of this object

  char *oql ();
  // Return the OQL string equivalent of this object

  TagExpList* tagexplist(TagExpList* tl);
  // Symbolic simplification of all tagexpressions linked to this

#ifdef _PROLOG_
  SP_term_ref sp_prolog ();
    // convert kola tree into prolog term and return it.
#endif // _PROLOG_ 

protected:
  TagExp* _tagexp;
  TagExpLink * next;
};

# endif
