/* -*-Mode:c++-*- */


//////////////////////////////////////////////////////////////////////////////
//
// NAME: Mitch Cherniack (mfc@cs.brown.edu)					 	 
// FILE: main.c
// PROJ: KOLA Parser, AQUA Translator
// DATE: 5/95
//
//////////////////////////////////////////////////////////////////////////////

#include "KGlobals.H"

#include "KOObject.H"
#include "TYTAny.H"
#include "KOBool.H"
#include "TYTUnk.H"
#include "TYTSet.H"
#include "TYTInt.H"
#include "TYTTup.H"
#include "KOFunction.H"
#include "KOFID.H"

#include "PAParser.H"
#include "KONonType.H"
#include "KOPredicate.H"

#include <iostream.h>


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  main
// Parameters:	   int, char * []	
// Returns:
//
// Parses all query files provided as input:
//
//   e.g.  parse query1 query2 ... queryn
//
// printing out their resulting EAT's in succession.
//         								    
//////////////////////////////////////////////////////////////////////////////


main (int argc, char *argv[])  {
  
  char *rep = NULL;
  char *oqlrep = NULL;
  char *sqlrep = NULL;
  
  if (argc >= 1) {
	
	int c;
	int res = F;
	int oql = F;
	int sql = F;
	
    while (--argc > 0 && (*++argv) [0] == '-')
	  while (c = *++argv[0])
	    switch (c) 
		  {
		  case 'r':
			res = T;
			break;
			
		  case 'o':
			oql = T;
			break;
			
		  case 's':
			sql = T;
			break;
		
		  default:
			cout << "kola: illegal option " << (char) c << endl;
			argc = 0;
			break;
			
		  };

    if (argc != 1)
	  cout << "Usage: kola [-ros] <Query File>" << endl;
    else 
	  {
		PAParser *p = new PAParser (*argv);
		if (p == NULL)
		  cout << "Null Parser Object." << endl;
		else 
		  {
			NonType *k = p -> parse ();
			if (k == NULL)
			  cout << "Parse Failed" << endl;	      
			else 
			  {
				if (k -> Myname () -> tag == ONAME) 
				  {
					koObject *koo = (koObject *) k;
					if (res == T)
					  rep = koo -> representation ();
					if (oql == T)
					  oqlrep = koo -> oql ();
					if (sql == T)
					  sqlrep = koo -> sql ();
				  } 
				else if (k -> Myname () -> tag == BNAME)
				  {
					koBool *kbo = (koBool *) k;
					if (res == T)
					  rep = kbo -> representation ();
					if (oql == T)
					  oqlrep = kbo -> oql ();
					if (sql == T)
					  sqlrep = kbo -> sql ();
				  } 
				else
				  cout << "Should Not Get Here - Parse returned a Function or Predicare." << endl;

				cout << endl;
	   
				if (res == T) cout << rep << endl << endl;		   
				if (oql == T) cout << oqlrep << endl << endl;		   
				if (sql == T) cout << sqlrep << endl << endl;		   
				
				if (rep) { delete [] rep; rep = NULL;}
				if (oqlrep) { delete [] oqlrep; oqlrep = NULL;}
				if (sqlrep) { delete [] sqlrep; sqlrep = NULL;}

				if (k) { delete k; k = NULL; }
				
			  }
		  };
		delete p;
	  }
  } else
	cout << "Usage: kola [-rx] <Query File>" << endl;
}





