/*
 * Copyright 1994, Brown University, Providence, RI
 *
 * Permission to use and modify this software and its documentation for
 * any purpose other than its incorporation into a commercial product is
 * hereby granted without fee.  Permission to copy and distribute this
 * software and its documentation only for non-commercial use is also
 * granted without fee, provided, however, that the above copyright notice
 * appear in all copies, that both that copyright notice and this permission
 * notice appear in supporting documentation, that the name of Brown
 * University not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission,
 * and that the person doing the distribution notify Brown University of
 * such distributions outside of his or her organization. Brown University
 * makes no representations about the suitability of this software for
 * any purpose.  It is provided "as is" without express or implied warranty.
 * Brown University requests notification of any modifications to this
 * software or its documentation.
 *
 * Send the following redistribution information:
 *
 *      Name:
 *      Organization:
 *      Address (postal and/or electronic):
 *
 * To:
 *      Software Librarian
 *      Computer Science Department, Box 1910
 *      Brown University
 *      Providence, RI 02912
 *
 *              or
 *
 *      brusd@cs.brown.edu
 *
 * We will acknowledge all electronic notifications.
 */

/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Mitch Cherniack (mfc)					 	    
//  FILE: TYTPair.H 
//  PROJ: KOLA
//  DATE: 5/95		                                                    
//
// SYNOPSIS
//  Pair Object Type
//
//////////////////////////////////////////////////////////////////////////////

#ifndef KOLA_TPAIR_HEADER
#define KOLA_TPAIR_HEADER 

#include "../KGlobals.H"
#include "TYTObj.H"

#include <string.h>

class TPair : public TObj
{
    
 public:
  TPair (TObj* o1, TObj* t2);
  //  Constructor.
  
  TPair (TPair& other);
  //  Copy Constructor. 
  
  ~TPair ();
  //  Destructor. 

  TObj *Copy ();
  // Virtual Copy Constructor
    
  TObj* One () {return one;}
  //  What is the TObj that is the first argument?

  TObj* Two () {return two;}
  //  What is the TObj that is the first argument?

  TPair* asPair () {return this;}
  // Coercer.
  koType* transformation () {return Copy();}    
  char *representation ();
  // Return textual representation of this    

  char* prolog ();
  // Return string representation of type in prolog term.

#ifdef _PROLOG_
  SP_term_ref sp_prolog ();
  // convert kola tree into prolog term and return it.
#endif // _PROLOG_
  
  int sameas (TObj *other)
    {return ((other -> Identity () == TYPE_ANY) ||
	     (other -> Identity () == TYPE_PAIR && one -> sameas (other -> asPair () -> One ()) && two -> sameas (other -> asPair () -> Two ())));}
  // Pair is same type as other pair if both are pairs of same types.
    
 protected:
  TObj* one;
  //  What type if the first member of the pair?
  
  TObj* two;
  //  What type is the second member of the pair?
  
};

# endif

