/*
 * Copyright 1994, Brown University, Providence, RI
 *
 * Permission to use and modify this software and its documentation for
 * any purpose other than its incorporation into a commercial product is
 * hereby granted without fee.  Permission to copy and distribute this
 * software and its documentation only for non-commercial use is also
 * granted without fee, provided, however, that the above copyright notice
 * appear in all copies, that both that copyright notice and this permission
 * notice appear in supporting documentation, that the name of Brown
 * University not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission,
 * and that the person doing the distribution notify Brown University of
 * such distributions outside of his or her organization. Brown University
 * makes no representations about the suitability of this software for
 * any purpose.  It is provided "as is" without express or implied warranty.
 * Brown University requests notification of any modifications to this
 * software or its documentation.
 *
 * Send the following redistribution information:
 *
 *      Name:
 *      Organization:
 *      Address (postal and/or electronic):
 *
 * To:
 *      Software Librarian
 *      Computer Science Department, Box 1910
 *      Brown University
 *      Providence, RI 02912
 *
 *              or
 *
 *      brusd@cs.brown.edu
 *
 * We will acknowledge all electronic notifications.
 */

/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Mitch Cherniack (mfc)					 	    
//  FILE: TYType.H 
//  PROJ: KOLA
//  DATE: 5/95		                                                    
//
// SYNOPSIS
//  The abstract type of koType objects, which includes as 
//  subclasses, Object, Function and Predicate Types.
//  For now, I will not implement the "inners" of these
//  classes except as stubs.  Eventually, they
//  can be used for type-checking queries.
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef KOLA_TYPE_HEADER
#define KOLA_TYPE_HEADER 

#include "../KGlobals.H"
#include "SPPROLOG.H"


class koType
{
public:
  virtual char* representation () = 0;
  //  Return string representation of koType.

  virtual char* prolog () = 0;
  // Return string representation of type in prolog term.

#ifdef _PROLOG_
  virtual SP_term_ref sp_prolog () = 0;
  // convert kola tree into prolog term and return it.
#endif // _PROLOG_

  virtual koType* transformation () = 0;
  // Return copy of itself
};


#endif


