/* -*-Mode:c++*- */

//////////////////////////////////////////////////////////////////
//
// Name: Xiaoyu Wang(wangxy@cs.brandeis.edu)
// File: QLAuxCode.H
// Project: XMLQL -> KOLA
// Date: 10/00
//
//////////////////////////////////////////////////////////////////

#ifndef	QLAUXCODE_HEADER
#define QLAUXCODE_HEADER

#include "KGlobals.H"
#include "KOBAnd.H"
#include "KOBEqu.H"
#include "KOBGE.H"
#include "KOBGT.H"
#include "KOBInvoke.H"
#include "KOBLE.H"
#include "KOBLT.H"
#include "KOBName.H"
#include "KOBNot.H"
#include "KOBOr.H"
#include "KOBPrimitive.H"
#include "KOBVar.H"
#include "KOBool.H"
#include "KOFTID.H"
#include "KOF1.H"
#include "KOF2.H"
#include "KOFAbs.H"
#include "KOFAdd.H"
#include "KOFAvg.H"
#include "KOFCElt.H"
#include "KOFChoose.H"
#include "KOFCompose.H"
#include "KOFCon.H"
#include "KOFConst.H"
#include "KOFCount.H"
#include "KOFDif.H"
#include "KOFDiv.H"
#include "KOFFlatten.H"
#include "KOFFold.H"
#include "KOFID.H"
#include "KOFIns.H"
#include "KOFInt.H"
#include "KOFInverse.H"
#include "KOFIter.H"
#include "KOFIterate.H"
#include "KOFJoin.H"
#include "KOFLSJoin.H"
#include "KOFMax.H"
#include "KOFMin.H"
#include "KOFMinus.H"
#include "KOFMod.H"
#include "KOFMult.H"
#include "KOFNJoin.H"
#include "KOFPCon.H"
#include "KOFPFold.H"
#include "KOFPlus.H"
#include "KOFRSJoin.H"
#include "KOFSet.H"
#include "KOFSingleton.H"
#include "KOFSort.H"
#include "KOFSum.H"
#include "KOFTimes.H"
#include "KOFUni.H"
#include "KOFUnnest.H"
#include "KOFUser.H"
#include "KOFVar.H"
#include "KOFunction.H"
#include "KONameUnion.H"
#include "KONonType.H"
#include "KOOAny.H"
#include "KOODif.H"
#include "KOODiv.H"
#include "KOOFloat.H"
#include "KOOId.H"
#include "KOOIf.H"
#include "KOOInt.H"
#include "KOOInter.H"
#include "KOOInvoke.H"
#include "KOOLink.H"
#include "KOOMinus.H"
#include "KOOMult.H"
#include "KOOName.H"
#include "KOOPair.H"
#include "KOOPlus.H"
#include "KOOSet.H"
#include "KOOStr.H"
#include "KOOTimes.H"
#include "KOOUni.H"
#include "KOOVar.H"
#include "KOObjList.H"
#include "KOObject.H"
#include "KOPCEX.H"
#include "KOPCElt.H"
#include "KOPCFA.H"
#include "KOPCombine.H"
#include "KOPConjunct.H"
#include "KOPConst.H"
#include "KOPDisjunct.H"
#include "KOPEqual.H"
#include "KOPExists.H"
#include "KOPForall.H"
#include "KOPGreater.H"
#include "KOPGreaterEqual.H"
#include "KOPInv.H"
#include "KOPIsnotnull.H"
#include "KOPIsnull.H"
#include "KOPLess.H"
#include "KOPLessEqual.H"
#include "KOPLex.H"
#include "KOPNegate.H"
#include "KOPNotEqual.H"
#include "KOPTimes.H"
#include "KOPUser.H"
#include "KOPVar.H"
#include "KOPredicate.H"
#include "KOTWrap.H"

#include "TYTAny.H"
#include "TYTBag.H"
#include "TYTBool.H"
#include "TYTChar.H"
#include "TYTDC.H"
#include "TYTError.H"
#include "TYTFlt.H"
#include "TYTFunc.H"
#include "TYTInt.H"
#include "TYTObj.H"
#include "TYTPair.H"
#include "TYTPred.H"
#include "TYTSet.H"
#include "TYTStr.H"
#include "TYTTup.H"
#include "TYTUnk.H"
#include "TYTUser.H"
#include "TYTVar.H"
#include "TYType.H"

#include "KOTagExp.H"
#include "KOTag.H"
#include "KOTTilde.H"
#include "KOTDollar.H"
#include "KOTQuestion.H"
#include "KOTBang.H"
#include "KOTDoubleBang.H"
#include "KOTLArrow.H"
#include "KOTStar.H"
#include "KOTPlus.H"
#include "KOTAlt.H"
#include "KOTSt.H"
#include "KOTAlt.H"
#include "KOTElem.H"
#include "KOTAttr.H"
#include "KOPMatch.H"
#include "KOFExtract.H"
#include "KOFEle.H"
#include "KOFElt.H"
#include "KOFApp.H"
#include "KOFValue.H"
#include "KOTagExpList.H"


#include "ENEnvironment.H"
#include "ENEnvEntry.H"

#include <iostream.h>
#include <strings.h>
#include <string.h>

Function  *CopyFunc ( Function *f );
Predicate *CopyPred ( Predicate *p );
TagExp    *CopyTagExp ( TagExp *t );
Tag       *CopyTag ( Tag * t );


Function *QFunc (Function *f1, Predicate *p, Function *f2);
Function *QFunc (Function *f1, Function *f2);

Function *InListTransFunc (Function *f);
Function *InListTransFunc (Function *f1, Function *f2);

Function *InTransFunc (char *type, TagExp *t1, TagExp *t2, char *s);

Tag *TpTag (char *id);

TagExp *TpTransTagExp (char *id );
TagExp *TpTransTagExp (TagExp *t );
TagExp *TpTransTagExp (char *id, char *str );

TagExp *TpEnvTagExp (TagExp *t, char *id, char *s);

TagExp *TpEnvTagExp (int no, TagExp *t1, TagExp *t2, Tag *t, char *v );
TagExp *TpTransTagExp (char *id, TagExpList* t);
TagExpList *TpListTransTagExpList (TagExp *t);
TagExpList *TpListTransTagExpList (TagExp *t, TagExpList* tl );

TagExp *TpListEnvTagExp (TagExp *t1, TagExp *t2);
TagExp *TpEnvTagExp ();

Function *ConsTransFunc (Function *s);

Function *ElemTransFunc (char *s);
TagExp *TpListPathTagExp (char *id, TagExp *t);

Function *ElemTransFunc (int no, char *s1, char *s2);
Function *ElemTransFunc (char *str, Function *f);
Function *ElemListTransFunc (Function *f1, Function *f2);
Predicate *WhereTransPred (Predicate *p1, Predicate *p1);
Predicate *CondTransPred (char *type, Function *f1, Function *f2);
Function  *ExpTransFunc (char *type, char *s);

TagExp* TpPathTagExp ();
TagExp* TpTEnvTagExp ();
TagExp* TpFEnvTagExp ();

#endif
