/* output from Ox version G1.04 */
%{

#include "oxout.tab.h"
#include "KGlobals.H"
#include "KONonType.H"
#include <string.h>
#include <stdio.h>

int lineno3 = 1;
extern "C" { int atoi(const char *s); }

char  *lexeme()
{
  char * res;

  if(yytext[0] == '$') { res = new char[yyleng]; 
                         strcpy(res, yytext+1); }
   else { if(yytext[0] == '"'){ res = new char[yyleng-1];
                             strncpy(res, yytext+1, yyleng-2); 
                             res[yyleng-2] ='\0'; }
          else { res = new char[yyleng+1];
                 strcpy(res, yytext); }
  }
	
  return res;	

}

%}


%{


struct yyyT1 {char *str;}; 
typedef struct yyyT1 *yyyP1; 


struct yyyT2 {Tag *tag; TagExp *path;  TagExp *trans; TagExp *env;}; 
typedef struct yyyT2 *yyyP2; 


struct yyyT3 {TagExp *path; TagExpList *trans; TagExp *env;}; 
typedef struct yyyT3 *yyyP3; 


struct yyyT4 {Function *trans ;}; 
typedef struct yyyT4 *yyyP4; 


struct yyyT5 {Predicate *trans;}; 
typedef struct yyyT5 *yyyP5; 
                                                      /*custom*/  
typedef unsigned char yyyWAT; 
typedef unsigned char yyyRCT; 
typedef unsigned short yyyPNT; 
typedef unsigned char yyyWST; 

#include <limits.h>
#define yyyR UCHAR_MAX  

 /* funny type; as wide as the widest of yyyWAT,yyyWST,yyyRCT  */ 
typedef unsigned short yyyFT;

                                                      /*stock*/  




struct yyyGenNode {void *parent;  
                   struct yyyGenNode **cL; /* child list */ 
                   yyyRCT *refCountList; 
                   yyyPNT prodNum;                      
                   yyyWST whichSym; /* which child of parent? */ 
                  }; 

typedef struct yyyGenNode yyyGNT; 



struct yyyTB {int isEmpty; 
              int typeNum; 
              int nAttrbs; 
              char *snBufPtr; 
              yyyWAT *startP,*stopP; 
             };  




extern struct yyyTB yyyTermBuffer; 
extern yyyWAT yyyLRCIL[]; 
extern void yyyGenLeaf(int nAttrbs,int typeNum,
                       yyyWAT *startP,yyyWAT *stopP
                      ); 


%}
%%

"<"  				{  {yyyGenLeaf(0,0,yyyLRCIL+0,yyyLRCIL+0);return  LT;} 		}  

">"  				{  {yyyGenLeaf(0,0,yyyLRCIL+0,yyyLRCIL+0);return  GT;}		}

"/>" 				{  {yyyGenLeaf(0,0,yyyLRCIL+0,yyyLRCIL+0);return  SLASHGT;}	} 

"</" 				{  {yyyGenLeaf(0,0,yyyLRCIL+0,yyyLRCIL+0);return  LTSLASH;}	}

","				{  {yyyGenLeaf(0,0,yyyLRCIL+0,yyyLRCIL+0);return  COMMA;}	}

"="				{  {yyyGenLeaf(0,0,yyyLRCIL+0,yyyLRCIL+0);return  EQ;}		}

"<>"				{  {yyyGenLeaf(0,0,yyyLRCIL+0,yyyLRCIL+0);return  NEQ;}		}

"{"				{  {yyyGenLeaf(0,0,yyyLRCIL+0,yyyLRCIL+0);return  LBRACE;}	}

"}"				{  {yyyGenLeaf(0,0,yyyLRCIL+0,yyyLRCIL+0);return  RBRACE;}	}

"*"				{  {yyyGenLeaf(0,0,yyyLRCIL+0,yyyLRCIL+0);return STAR;}		}

"+"				{  {yyyGenLeaf(0,0,yyyLRCIL+0,yyyLRCIL+0);return  PLUS;}        }

"."				{   {yyyGenLeaf(0,0,yyyLRCIL+0,yyyLRCIL+0);return DOT;}         }

"|"                             {   {yyyGenLeaf(0,0,yyyLRCIL+0,yyyLRCIL+0);return  BAR;}        }

[iI][nN]			{  {yyyGenLeaf(0,0,yyyLRCIL+0,yyyLRCIL+0);return  INN;}		}

$[a-zA-Z][a-zA-Z0-9_]*		{    
                                   {yyyGenLeaf(1,1,yyyLRCIL+0,yyyLRCIL+1);  (((yyyP1)(yyyTermBuffer.snBufPtr))->str) = lexeme(); return VAR;}
				    
				}

[eE][lL][eE][mM][eE][nN][tT][_][aA][sS]	{  {yyyGenLeaf(0,0,yyyLRCIL+1,yyyLRCIL+1);return  ELEMENTAS;}	}

[cC][oO][nN][tT][eE][nN][tT][_][aA][sS]	{  {yyyGenLeaf(0,0,yyyLRCIL+1,yyyLRCIL+1);return  CONTENTAS;}	}

[wW][hH][eE][rR][eE]		{  {yyyGenLeaf(0,0,yyyLRCIL+1,yyyLRCIL+1);return  WHERE;}		}

[cC][oO][nN][sS][tT][rR][uU][cC][tT]	{  {yyyGenLeaf(0,0,yyyLRCIL+1,yyyLRCIL+1);return  CONSTRUCT;}	}

[ \n\t\f]*        			;   

\"[^\"\n]*\"			{   
                                    {yyyGenLeaf(1,1,yyyLRCIL+1,yyyLRCIL+2); (((yyyP1)(yyyTermBuffer.snBufPtr))->str) = lexeme();  return  STRING;}
				  
				}

([a-zA-Z][a-zA-Z0-9_]*)		{   {yyyGenLeaf(1,1,yyyLRCIL+2,yyyLRCIL+3); (((yyyP1)(yyyTermBuffer.snBufPtr))->str) = lexeme(); return  ID;}
				  
                                }

[.]*				{  fprintf(stderr,"illegal character\n"); 
				   exit(-1); 
               			} 

%%

int yywrap() { return 1; }












